# coding: utf-8

"""
    Yahoo!広告 検索広告 API リファレンス / Yahoo! JAPAN Ads Search Ads API Reference

    <div lang=\"ja\">Yahoo!広告 検索広告 APIのWebサービスについて説明します。</div> <div lang=\"en\">Search Ads API Web Services supported in Yahoo! JAPAN Ads API.</div> <div><a target=\"_blank\" href=\"https://github.com/yahoojp-marketing/ads-search-api-documents/blob/master/design/v12/Route.yaml\">OpenAPI Specification</a></div> <div lang=\"ja\"><a target=\"_blank\" href=\"https://github.com/yahoojp-marketing/ads-search-api-documents/blob/master/bestpractice/ja\">Best Practice</a></div> <div lang=\"en\"><a target=\"_blank\" href=\"https://github.com/yahoojp-marketing/ads-search-api-documents/blob/master/bestpractice/en\">Best Practice</a></div>   # noqa: E501

    The version of the OpenAPI document: v12
    Generated by: https://openapi-generator.tech
"""


from __future__ import absolute_import

import re  # noqa: F401

# python 2 and python 3 compatibility library
import six

from yahoo_search_api_v12.api_client import ApiClient
from yahoo_search_api_v12.exceptions import (  # noqa: F401
    ApiTypeError,
    ApiValueError
)


class PageFeedAssetServiceApi(object):
    """NOTE: This class is auto generated by OpenAPI Generator
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    def __init__(self, api_client=None):
        if api_client is None:
            api_client = ApiClient()
        self.api_client = api_client

    def page_feed_asset_service_add_download_job_post(self, x_z_base_account_id, **kwargs):  # noqa: E501
        """page_feed_asset_service_add_download_job_post  # noqa: E501

        <div lang=\"ja\">登録されているページフィードアセットを一括でダウンロードするためジョブを登録します。</div> <div lang=\"en\">Registers job to bulk download registered page feed asset.</div>   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.page_feed_asset_service_add_download_job_post(x_z_base_account_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool: execute request asynchronously
        :param int x_z_base_account_id: <div lang=\"ja\">アカウントIDを指定してください。</div> <div lang=\"en\">Specify Account ID.</div>  (required)
        :param PageFeedAssetServiceAddDownloadJobOperation page_feed_asset_service_add_download_job_operation:
        :param _preload_content: if False, the urllib3.HTTPResponse object will
                                 be returned without reading/decoding response
                                 data. Default is True.
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :return: PageFeedAssetServiceAddDownloadJobResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        return self.page_feed_asset_service_add_download_job_post_with_http_info(x_z_base_account_id, **kwargs)  # noqa: E501

    def page_feed_asset_service_add_download_job_post_with_http_info(self, x_z_base_account_id, **kwargs):  # noqa: E501
        """page_feed_asset_service_add_download_job_post  # noqa: E501

        <div lang=\"ja\">登録されているページフィードアセットを一括でダウンロードするためジョブを登録します。</div> <div lang=\"en\">Registers job to bulk download registered page feed asset.</div>   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.page_feed_asset_service_add_download_job_post_with_http_info(x_z_base_account_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool: execute request asynchronously
        :param int x_z_base_account_id: <div lang=\"ja\">アカウントIDを指定してください。</div> <div lang=\"en\">Specify Account ID.</div>  (required)
        :param PageFeedAssetServiceAddDownloadJobOperation page_feed_asset_service_add_download_job_operation:
        :param _return_http_data_only: response data without head status code
                                       and headers
        :param _preload_content: if False, the urllib3.HTTPResponse object will
                                 be returned without reading/decoding response
                                 data. Default is True.
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :return: tuple(PageFeedAssetServiceAddDownloadJobResponse, status_code(int), headers(HTTPHeaderDict))
                 If the method is called asynchronously,
                 returns the request thread.
        """

        local_var_params = locals()

        all_params = [
            'x_z_base_account_id',
            'page_feed_asset_service_add_download_job_operation'
        ]
        all_params.extend(
            [
                'async_req',
                '_return_http_data_only',
                '_preload_content',
                '_request_timeout'
            ]
        )

        for key, val in six.iteritems(local_var_params['kwargs']):
            if key not in all_params:
                raise ApiTypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method page_feed_asset_service_add_download_job_post" % key
                )
            local_var_params[key] = val
        del local_var_params['kwargs']
        # verify the required parameter 'x_z_base_account_id' is set
        if self.api_client.client_side_validation and ('x_z_base_account_id' not in local_var_params or  # noqa: E501
                                                        local_var_params['x_z_base_account_id'] is None):  # noqa: E501
            raise ApiValueError("Missing the required parameter `x_z_base_account_id` when calling `page_feed_asset_service_add_download_job_post`")  # noqa: E501

        collection_formats = {}

        path_params = {}

        query_params = []

        header_params = {}
        if 'x_z_base_account_id' in local_var_params:
            header_params['x-z-base-account-id'] = local_var_params['x_z_base_account_id']  # noqa: E501

        form_params = []
        local_var_files = {}

        body_params = None
        if 'page_feed_asset_service_add_download_job_operation' in local_var_params:
            body_params = local_var_params['page_feed_asset_service_add_download_job_operation']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['oAuth']  # noqa: E501

        return self.api_client.call_api(
            '/PageFeedAssetService/addDownloadJob', 'POST',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='PageFeedAssetServiceAddDownloadJobResponse',  # noqa: E501
            auth_settings=auth_settings,
            async_req=local_var_params.get('async_req'),
            _return_http_data_only=local_var_params.get('_return_http_data_only'),  # noqa: E501
            _preload_content=local_var_params.get('_preload_content', True),
            _request_timeout=local_var_params.get('_request_timeout'),
            collection_formats=collection_formats)

    def page_feed_asset_service_download_error_file_post(self, x_z_base_account_id, **kwargs):  # noqa: E501
        """page_feed_asset_service_download_error_file_post  # noqa: E501

        <div lang=\"ja\">ページフィードアセットのエラーファイルをダウンロードします。</div> <div lang=\"en\">Download the error file of page feed assets.</div>   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.page_feed_asset_service_download_error_file_post(x_z_base_account_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool: execute request asynchronously
        :param int x_z_base_account_id: <div lang=\"ja\">アカウントIDを指定してください。</div> <div lang=\"en\">Specify Account ID.</div>  (required)
        :param PageFeedAssetServiceDownloadSelector page_feed_asset_service_download_selector:
        :param _preload_content: if False, the urllib3.HTTPResponse object will
                                 be returned without reading/decoding response
                                 data. Default is True.
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :return: file
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        return self.page_feed_asset_service_download_error_file_post_with_http_info(x_z_base_account_id, **kwargs)  # noqa: E501

    def page_feed_asset_service_download_error_file_post_with_http_info(self, x_z_base_account_id, **kwargs):  # noqa: E501
        """page_feed_asset_service_download_error_file_post  # noqa: E501

        <div lang=\"ja\">ページフィードアセットのエラーファイルをダウンロードします。</div> <div lang=\"en\">Download the error file of page feed assets.</div>   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.page_feed_asset_service_download_error_file_post_with_http_info(x_z_base_account_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool: execute request asynchronously
        :param int x_z_base_account_id: <div lang=\"ja\">アカウントIDを指定してください。</div> <div lang=\"en\">Specify Account ID.</div>  (required)
        :param PageFeedAssetServiceDownloadSelector page_feed_asset_service_download_selector:
        :param _return_http_data_only: response data without head status code
                                       and headers
        :param _preload_content: if False, the urllib3.HTTPResponse object will
                                 be returned without reading/decoding response
                                 data. Default is True.
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :return: tuple(file, status_code(int), headers(HTTPHeaderDict))
                 If the method is called asynchronously,
                 returns the request thread.
        """

        local_var_params = locals()

        all_params = [
            'x_z_base_account_id',
            'page_feed_asset_service_download_selector'
        ]
        all_params.extend(
            [
                'async_req',
                '_return_http_data_only',
                '_preload_content',
                '_request_timeout'
            ]
        )

        for key, val in six.iteritems(local_var_params['kwargs']):
            if key not in all_params:
                raise ApiTypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method page_feed_asset_service_download_error_file_post" % key
                )
            local_var_params[key] = val
        del local_var_params['kwargs']
        # verify the required parameter 'x_z_base_account_id' is set
        if self.api_client.client_side_validation and ('x_z_base_account_id' not in local_var_params or  # noqa: E501
                                                        local_var_params['x_z_base_account_id'] is None):  # noqa: E501
            raise ApiValueError("Missing the required parameter `x_z_base_account_id` when calling `page_feed_asset_service_download_error_file_post`")  # noqa: E501

        collection_formats = {}

        path_params = {}

        query_params = []

        header_params = {}
        if 'x_z_base_account_id' in local_var_params:
            header_params['x-z-base-account-id'] = local_var_params['x_z_base_account_id']  # noqa: E501

        form_params = []
        local_var_files = {}

        body_params = None
        if 'page_feed_asset_service_download_selector' in local_var_params:
            body_params = local_var_params['page_feed_asset_service_download_selector']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/octet-stream'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['oAuth']  # noqa: E501

        return self.api_client.call_api(
            '/PageFeedAssetService/downloadErrorFile', 'POST',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='file',  # noqa: E501
            auth_settings=auth_settings,
            async_req=local_var_params.get('async_req'),
            _return_http_data_only=local_var_params.get('_return_http_data_only'),  # noqa: E501
            _preload_content=local_var_params.get('_preload_content', True),
            _request_timeout=local_var_params.get('_request_timeout'),
            collection_formats=collection_formats)

    def page_feed_asset_service_download_post(self, x_z_base_account_id, **kwargs):  # noqa: E501
        """page_feed_asset_service_download_post  # noqa: E501

        <div lang=\"ja\">ページフィードアセットをダウンロードします。</div> <div lang=\"en\">Download page feed assets.</div>   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.page_feed_asset_service_download_post(x_z_base_account_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool: execute request asynchronously
        :param int x_z_base_account_id: <div lang=\"ja\">アカウントIDを指定してください。</div> <div lang=\"en\">Specify Account ID.</div>  (required)
        :param PageFeedAssetServiceDownloadSelector page_feed_asset_service_download_selector:
        :param _preload_content: if False, the urllib3.HTTPResponse object will
                                 be returned without reading/decoding response
                                 data. Default is True.
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :return: file
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        return self.page_feed_asset_service_download_post_with_http_info(x_z_base_account_id, **kwargs)  # noqa: E501

    def page_feed_asset_service_download_post_with_http_info(self, x_z_base_account_id, **kwargs):  # noqa: E501
        """page_feed_asset_service_download_post  # noqa: E501

        <div lang=\"ja\">ページフィードアセットをダウンロードします。</div> <div lang=\"en\">Download page feed assets.</div>   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.page_feed_asset_service_download_post_with_http_info(x_z_base_account_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool: execute request asynchronously
        :param int x_z_base_account_id: <div lang=\"ja\">アカウントIDを指定してください。</div> <div lang=\"en\">Specify Account ID.</div>  (required)
        :param PageFeedAssetServiceDownloadSelector page_feed_asset_service_download_selector:
        :param _return_http_data_only: response data without head status code
                                       and headers
        :param _preload_content: if False, the urllib3.HTTPResponse object will
                                 be returned without reading/decoding response
                                 data. Default is True.
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :return: tuple(file, status_code(int), headers(HTTPHeaderDict))
                 If the method is called asynchronously,
                 returns the request thread.
        """

        local_var_params = locals()

        all_params = [
            'x_z_base_account_id',
            'page_feed_asset_service_download_selector'
        ]
        all_params.extend(
            [
                'async_req',
                '_return_http_data_only',
                '_preload_content',
                '_request_timeout'
            ]
        )

        for key, val in six.iteritems(local_var_params['kwargs']):
            if key not in all_params:
                raise ApiTypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method page_feed_asset_service_download_post" % key
                )
            local_var_params[key] = val
        del local_var_params['kwargs']
        # verify the required parameter 'x_z_base_account_id' is set
        if self.api_client.client_side_validation and ('x_z_base_account_id' not in local_var_params or  # noqa: E501
                                                        local_var_params['x_z_base_account_id'] is None):  # noqa: E501
            raise ApiValueError("Missing the required parameter `x_z_base_account_id` when calling `page_feed_asset_service_download_post`")  # noqa: E501

        collection_formats = {}

        path_params = {}

        query_params = []

        header_params = {}
        if 'x_z_base_account_id' in local_var_params:
            header_params['x-z-base-account-id'] = local_var_params['x_z_base_account_id']  # noqa: E501

        form_params = []
        local_var_files = {}

        body_params = None
        if 'page_feed_asset_service_download_selector' in local_var_params:
            body_params = local_var_params['page_feed_asset_service_download_selector']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/octet-stream'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['oAuth']  # noqa: E501

        return self.api_client.call_api(
            '/PageFeedAssetService/download', 'POST',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='file',  # noqa: E501
            auth_settings=auth_settings,
            async_req=local_var_params.get('async_req'),
            _return_http_data_only=local_var_params.get('_return_http_data_only'),  # noqa: E501
            _preload_content=local_var_params.get('_preload_content', True),
            _request_timeout=local_var_params.get('_request_timeout'),
            collection_formats=collection_formats)

    def page_feed_asset_service_get_job_status_post(self, x_z_base_account_id, **kwargs):  # noqa: E501
        """page_feed_asset_service_get_job_status_post  # noqa: E501

        <div lang=\"ja\">upload、downloadの処理状況を取得します。</div> <div lang=\"en\">Gets processing status about upload or download.</div>   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.page_feed_asset_service_get_job_status_post(x_z_base_account_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool: execute request asynchronously
        :param int x_z_base_account_id: <div lang=\"ja\">アカウントIDを指定してください。</div> <div lang=\"en\">Specify Account ID.</div>  (required)
        :param PageFeedAssetServiceGetJobStatusSelector page_feed_asset_service_get_job_status_selector:
        :param _preload_content: if False, the urllib3.HTTPResponse object will
                                 be returned without reading/decoding response
                                 data. Default is True.
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :return: PageFeedAssetServiceGetJobStatusResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        return self.page_feed_asset_service_get_job_status_post_with_http_info(x_z_base_account_id, **kwargs)  # noqa: E501

    def page_feed_asset_service_get_job_status_post_with_http_info(self, x_z_base_account_id, **kwargs):  # noqa: E501
        """page_feed_asset_service_get_job_status_post  # noqa: E501

        <div lang=\"ja\">upload、downloadの処理状況を取得します。</div> <div lang=\"en\">Gets processing status about upload or download.</div>   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.page_feed_asset_service_get_job_status_post_with_http_info(x_z_base_account_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool: execute request asynchronously
        :param int x_z_base_account_id: <div lang=\"ja\">アカウントIDを指定してください。</div> <div lang=\"en\">Specify Account ID.</div>  (required)
        :param PageFeedAssetServiceGetJobStatusSelector page_feed_asset_service_get_job_status_selector:
        :param _return_http_data_only: response data without head status code
                                       and headers
        :param _preload_content: if False, the urllib3.HTTPResponse object will
                                 be returned without reading/decoding response
                                 data. Default is True.
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :return: tuple(PageFeedAssetServiceGetJobStatusResponse, status_code(int), headers(HTTPHeaderDict))
                 If the method is called asynchronously,
                 returns the request thread.
        """

        local_var_params = locals()

        all_params = [
            'x_z_base_account_id',
            'page_feed_asset_service_get_job_status_selector'
        ]
        all_params.extend(
            [
                'async_req',
                '_return_http_data_only',
                '_preload_content',
                '_request_timeout'
            ]
        )

        for key, val in six.iteritems(local_var_params['kwargs']):
            if key not in all_params:
                raise ApiTypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method page_feed_asset_service_get_job_status_post" % key
                )
            local_var_params[key] = val
        del local_var_params['kwargs']
        # verify the required parameter 'x_z_base_account_id' is set
        if self.api_client.client_side_validation and ('x_z_base_account_id' not in local_var_params or  # noqa: E501
                                                        local_var_params['x_z_base_account_id'] is None):  # noqa: E501
            raise ApiValueError("Missing the required parameter `x_z_base_account_id` when calling `page_feed_asset_service_get_job_status_post`")  # noqa: E501

        collection_formats = {}

        path_params = {}

        query_params = []

        header_params = {}
        if 'x_z_base_account_id' in local_var_params:
            header_params['x-z-base-account-id'] = local_var_params['x_z_base_account_id']  # noqa: E501

        form_params = []
        local_var_files = {}

        body_params = None
        if 'page_feed_asset_service_get_job_status_selector' in local_var_params:
            body_params = local_var_params['page_feed_asset_service_get_job_status_selector']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['oAuth']  # noqa: E501

        return self.api_client.call_api(
            '/PageFeedAssetService/getJobStatus', 'POST',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='PageFeedAssetServiceGetJobStatusResponse',  # noqa: E501
            auth_settings=auth_settings,
            async_req=local_var_params.get('async_req'),
            _return_http_data_only=local_var_params.get('_return_http_data_only'),  # noqa: E501
            _preload_content=local_var_params.get('_preload_content', True),
            _request_timeout=local_var_params.get('_request_timeout'),
            collection_formats=collection_formats)

    def page_feed_asset_service_get_post(self, x_z_base_account_id, **kwargs):  # noqa: E501
        """page_feed_asset_service_get_post  # noqa: E501

        <div lang=\"ja\">ページフィードアセット情報を取得します。</div> <div lang=\"en\">Gets information related to page feed asset.</div>   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.page_feed_asset_service_get_post(x_z_base_account_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool: execute request asynchronously
        :param int x_z_base_account_id: <div lang=\"ja\">アカウントIDを指定してください。</div> <div lang=\"en\">Specify Account ID.</div>  (required)
        :param PageFeedAssetServiceSelector page_feed_asset_service_selector:
        :param _preload_content: if False, the urllib3.HTTPResponse object will
                                 be returned without reading/decoding response
                                 data. Default is True.
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :return: PageFeedAssetServiceGetResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        return self.page_feed_asset_service_get_post_with_http_info(x_z_base_account_id, **kwargs)  # noqa: E501

    def page_feed_asset_service_get_post_with_http_info(self, x_z_base_account_id, **kwargs):  # noqa: E501
        """page_feed_asset_service_get_post  # noqa: E501

        <div lang=\"ja\">ページフィードアセット情報を取得します。</div> <div lang=\"en\">Gets information related to page feed asset.</div>   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.page_feed_asset_service_get_post_with_http_info(x_z_base_account_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool: execute request asynchronously
        :param int x_z_base_account_id: <div lang=\"ja\">アカウントIDを指定してください。</div> <div lang=\"en\">Specify Account ID.</div>  (required)
        :param PageFeedAssetServiceSelector page_feed_asset_service_selector:
        :param _return_http_data_only: response data without head status code
                                       and headers
        :param _preload_content: if False, the urllib3.HTTPResponse object will
                                 be returned without reading/decoding response
                                 data. Default is True.
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :return: tuple(PageFeedAssetServiceGetResponse, status_code(int), headers(HTTPHeaderDict))
                 If the method is called asynchronously,
                 returns the request thread.
        """

        local_var_params = locals()

        all_params = [
            'x_z_base_account_id',
            'page_feed_asset_service_selector'
        ]
        all_params.extend(
            [
                'async_req',
                '_return_http_data_only',
                '_preload_content',
                '_request_timeout'
            ]
        )

        for key, val in six.iteritems(local_var_params['kwargs']):
            if key not in all_params:
                raise ApiTypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method page_feed_asset_service_get_post" % key
                )
            local_var_params[key] = val
        del local_var_params['kwargs']
        # verify the required parameter 'x_z_base_account_id' is set
        if self.api_client.client_side_validation and ('x_z_base_account_id' not in local_var_params or  # noqa: E501
                                                        local_var_params['x_z_base_account_id'] is None):  # noqa: E501
            raise ApiValueError("Missing the required parameter `x_z_base_account_id` when calling `page_feed_asset_service_get_post`")  # noqa: E501

        collection_formats = {}

        path_params = {}

        query_params = []

        header_params = {}
        if 'x_z_base_account_id' in local_var_params:
            header_params['x-z-base-account-id'] = local_var_params['x_z_base_account_id']  # noqa: E501

        form_params = []
        local_var_files = {}

        body_params = None
        if 'page_feed_asset_service_selector' in local_var_params:
            body_params = local_var_params['page_feed_asset_service_selector']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['oAuth']  # noqa: E501

        return self.api_client.call_api(
            '/PageFeedAssetService/get', 'POST',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='PageFeedAssetServiceGetResponse',  # noqa: E501
            auth_settings=auth_settings,
            async_req=local_var_params.get('async_req'),
            _return_http_data_only=local_var_params.get('_return_http_data_only'),  # noqa: E501
            _preload_content=local_var_params.get('_preload_content', True),
            _request_timeout=local_var_params.get('_request_timeout'),
            collection_formats=collection_formats)

    def page_feed_asset_service_get_review_summary_post(self, x_z_base_account_id, **kwargs):  # noqa: E501
        """page_feed_asset_service_get_review_summary_post  # noqa: E501

        <div lang=\"ja\">登録されているページフィードアセットの審査成績・状況のサマリーを取得します。</div> <div lang=\"en\">Gets registered approval records of page feed asset and summary of each status.</div>   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.page_feed_asset_service_get_review_summary_post(x_z_base_account_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool: execute request asynchronously
        :param int x_z_base_account_id: <div lang=\"ja\">アカウントIDを指定してください。</div> <div lang=\"en\">Specify Account ID.</div>  (required)
        :param PageFeedAssetServiceGetReviewSummarySelector page_feed_asset_service_get_review_summary_selector:
        :param _preload_content: if False, the urllib3.HTTPResponse object will
                                 be returned without reading/decoding response
                                 data. Default is True.
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :return: PageFeedAssetServiceGetReviewSummaryResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        return self.page_feed_asset_service_get_review_summary_post_with_http_info(x_z_base_account_id, **kwargs)  # noqa: E501

    def page_feed_asset_service_get_review_summary_post_with_http_info(self, x_z_base_account_id, **kwargs):  # noqa: E501
        """page_feed_asset_service_get_review_summary_post  # noqa: E501

        <div lang=\"ja\">登録されているページフィードアセットの審査成績・状況のサマリーを取得します。</div> <div lang=\"en\">Gets registered approval records of page feed asset and summary of each status.</div>   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.page_feed_asset_service_get_review_summary_post_with_http_info(x_z_base_account_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool: execute request asynchronously
        :param int x_z_base_account_id: <div lang=\"ja\">アカウントIDを指定してください。</div> <div lang=\"en\">Specify Account ID.</div>  (required)
        :param PageFeedAssetServiceGetReviewSummarySelector page_feed_asset_service_get_review_summary_selector:
        :param _return_http_data_only: response data without head status code
                                       and headers
        :param _preload_content: if False, the urllib3.HTTPResponse object will
                                 be returned without reading/decoding response
                                 data. Default is True.
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :return: tuple(PageFeedAssetServiceGetReviewSummaryResponse, status_code(int), headers(HTTPHeaderDict))
                 If the method is called asynchronously,
                 returns the request thread.
        """

        local_var_params = locals()

        all_params = [
            'x_z_base_account_id',
            'page_feed_asset_service_get_review_summary_selector'
        ]
        all_params.extend(
            [
                'async_req',
                '_return_http_data_only',
                '_preload_content',
                '_request_timeout'
            ]
        )

        for key, val in six.iteritems(local_var_params['kwargs']):
            if key not in all_params:
                raise ApiTypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method page_feed_asset_service_get_review_summary_post" % key
                )
            local_var_params[key] = val
        del local_var_params['kwargs']
        # verify the required parameter 'x_z_base_account_id' is set
        if self.api_client.client_side_validation and ('x_z_base_account_id' not in local_var_params or  # noqa: E501
                                                        local_var_params['x_z_base_account_id'] is None):  # noqa: E501
            raise ApiValueError("Missing the required parameter `x_z_base_account_id` when calling `page_feed_asset_service_get_review_summary_post`")  # noqa: E501

        collection_formats = {}

        path_params = {}

        query_params = []

        header_params = {}
        if 'x_z_base_account_id' in local_var_params:
            header_params['x-z-base-account-id'] = local_var_params['x_z_base_account_id']  # noqa: E501

        form_params = []
        local_var_files = {}

        body_params = None
        if 'page_feed_asset_service_get_review_summary_selector' in local_var_params:
            body_params = local_var_params['page_feed_asset_service_get_review_summary_selector']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['oAuth']  # noqa: E501

        return self.api_client.call_api(
            '/PageFeedAssetService/getReviewSummary', 'POST',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='PageFeedAssetServiceGetReviewSummaryResponse',  # noqa: E501
            auth_settings=auth_settings,
            async_req=local_var_params.get('async_req'),
            _return_http_data_only=local_var_params.get('_return_http_data_only'),  # noqa: E501
            _preload_content=local_var_params.get('_preload_content', True),
            _request_timeout=local_var_params.get('_request_timeout'),
            collection_formats=collection_formats)

    def page_feed_asset_service_upload_post(self, x_z_base_account_id, account_id, upload_type, page_feed_asset_set_id, **kwargs):  # noqa: E501
        """page_feed_asset_service_upload_post  # noqa: E501

        <div lang=\"ja\">ページフィードアセットのアップロード処理を実施します。</div> <div lang=\"en\">Executes upload page feed asset.</div>   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.page_feed_asset_service_upload_post(x_z_base_account_id, account_id, upload_type, page_feed_asset_set_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool: execute request asynchronously
        :param int x_z_base_account_id: <div lang=\"ja\">アカウントIDを指定してください。</div> <div lang=\"en\">Specify Account ID.</div>  (required)
        :param int account_id: <div lang=\"ja\">アカウントIDです。</div> <div lang=\"en\">Account ID.</div>  (required)
        :param str upload_type: <div lang=\"ja\">PageFeedAssetUploadTypeは、アップロードする方法の種類を表します。</div> <div lang=\"en\">PageFeedAssetUploadType displays kind of upload method.</div>  (required)
        :param int page_feed_asset_set_id: <div lang=\"ja\">ページフィードアセットセットIDです。</div> <div lang=\"en\">PageFeedAssetSet ID.</div>  (required)
        :param file file:
        :param _preload_content: if False, the urllib3.HTTPResponse object will
                                 be returned without reading/decoding response
                                 data. Default is True.
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :return: PageFeedAssetServiceUploadResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        return self.page_feed_asset_service_upload_post_with_http_info(x_z_base_account_id, account_id, upload_type, page_feed_asset_set_id, **kwargs)  # noqa: E501

    def page_feed_asset_service_upload_post_with_http_info(self, x_z_base_account_id, account_id, upload_type, page_feed_asset_set_id, **kwargs):  # noqa: E501
        """page_feed_asset_service_upload_post  # noqa: E501

        <div lang=\"ja\">ページフィードアセットのアップロード処理を実施します。</div> <div lang=\"en\">Executes upload page feed asset.</div>   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.page_feed_asset_service_upload_post_with_http_info(x_z_base_account_id, account_id, upload_type, page_feed_asset_set_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool: execute request asynchronously
        :param int x_z_base_account_id: <div lang=\"ja\">アカウントIDを指定してください。</div> <div lang=\"en\">Specify Account ID.</div>  (required)
        :param int account_id: <div lang=\"ja\">アカウントIDです。</div> <div lang=\"en\">Account ID.</div>  (required)
        :param str upload_type: <div lang=\"ja\">PageFeedAssetUploadTypeは、アップロードする方法の種類を表します。</div> <div lang=\"en\">PageFeedAssetUploadType displays kind of upload method.</div>  (required)
        :param int page_feed_asset_set_id: <div lang=\"ja\">ページフィードアセットセットIDです。</div> <div lang=\"en\">PageFeedAssetSet ID.</div>  (required)
        :param file file:
        :param _return_http_data_only: response data without head status code
                                       and headers
        :param _preload_content: if False, the urllib3.HTTPResponse object will
                                 be returned without reading/decoding response
                                 data. Default is True.
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :return: tuple(PageFeedAssetServiceUploadResponse, status_code(int), headers(HTTPHeaderDict))
                 If the method is called asynchronously,
                 returns the request thread.
        """

        local_var_params = locals()

        all_params = [
            'x_z_base_account_id',
            'account_id',
            'upload_type',
            'page_feed_asset_set_id',
            'file'
        ]
        all_params.extend(
            [
                'async_req',
                '_return_http_data_only',
                '_preload_content',
                '_request_timeout'
            ]
        )

        for key, val in six.iteritems(local_var_params['kwargs']):
            if key not in all_params:
                raise ApiTypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method page_feed_asset_service_upload_post" % key
                )
            local_var_params[key] = val
        del local_var_params['kwargs']
        # verify the required parameter 'x_z_base_account_id' is set
        if self.api_client.client_side_validation and ('x_z_base_account_id' not in local_var_params or  # noqa: E501
                                                        local_var_params['x_z_base_account_id'] is None):  # noqa: E501
            raise ApiValueError("Missing the required parameter `x_z_base_account_id` when calling `page_feed_asset_service_upload_post`")  # noqa: E501
        # verify the required parameter 'account_id' is set
        if self.api_client.client_side_validation and ('account_id' not in local_var_params or  # noqa: E501
                                                        local_var_params['account_id'] is None):  # noqa: E501
            raise ApiValueError("Missing the required parameter `account_id` when calling `page_feed_asset_service_upload_post`")  # noqa: E501
        # verify the required parameter 'upload_type' is set
        if self.api_client.client_side_validation and ('upload_type' not in local_var_params or  # noqa: E501
                                                        local_var_params['upload_type'] is None):  # noqa: E501
            raise ApiValueError("Missing the required parameter `upload_type` when calling `page_feed_asset_service_upload_post`")  # noqa: E501
        # verify the required parameter 'page_feed_asset_set_id' is set
        if self.api_client.client_side_validation and ('page_feed_asset_set_id' not in local_var_params or  # noqa: E501
                                                        local_var_params['page_feed_asset_set_id'] is None):  # noqa: E501
            raise ApiValueError("Missing the required parameter `page_feed_asset_set_id` when calling `page_feed_asset_service_upload_post`")  # noqa: E501

        collection_formats = {}

        path_params = {}

        query_params = []
        if 'account_id' in local_var_params and local_var_params['account_id'] is not None:  # noqa: E501
            query_params.append(('accountId', local_var_params['account_id']))  # noqa: E501
        if 'upload_type' in local_var_params and local_var_params['upload_type'] is not None:  # noqa: E501
            query_params.append(('uploadType', local_var_params['upload_type']))  # noqa: E501
        if 'page_feed_asset_set_id' in local_var_params and local_var_params['page_feed_asset_set_id'] is not None:  # noqa: E501
            query_params.append(('pageFeedAssetSetId', local_var_params['page_feed_asset_set_id']))  # noqa: E501

        header_params = {}
        if 'x_z_base_account_id' in local_var_params:
            header_params['x-z-base-account-id'] = local_var_params['x_z_base_account_id']  # noqa: E501

        form_params = []
        local_var_files = {}
        if 'file' in local_var_params:
            local_var_files['file'] = local_var_params['file']  # noqa: E501

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['multipart/form-data'])  # noqa: E501

        # Authentication setting
        auth_settings = ['oAuth']  # noqa: E501

        return self.api_client.call_api(
            '/PageFeedAssetService/upload', 'POST',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='PageFeedAssetServiceUploadResponse',  # noqa: E501
            auth_settings=auth_settings,
            async_req=local_var_params.get('async_req'),
            _return_http_data_only=local_var_params.get('_return_http_data_only'),  # noqa: E501
            _preload_content=local_var_params.get('_preload_content', True),
            _request_timeout=local_var_params.get('_request_timeout'),
            collection_formats=collection_formats)
