# coding: utf-8

"""
    Yahoo!広告 検索広告 API リファレンス / Yahoo! JAPAN Ads Search Ads API Reference

    <div lang=\"ja\">Yahoo!広告 検索広告 APIのWebサービスについて説明します。</div> <div lang=\"en\">Search Ads API Web Services supported in Yahoo! JAPAN Ads API.</div> <div><a target=\"_blank\" href=\"https://github.com/yahoojp-marketing/ads-search-api-documents/blob/master/design/v12/Route.yaml\">OpenAPI Specification</a></div> <div lang=\"ja\"><a target=\"_blank\" href=\"https://github.com/yahoojp-marketing/ads-search-api-documents/blob/master/bestpractice/ja\">Best Practice</a></div> <div lang=\"en\"><a target=\"_blank\" href=\"https://github.com/yahoojp-marketing/ads-search-api-documents/blob/master/bestpractice/en\">Best Practice</a></div>   # noqa: E501

    The version of the OpenAPI document: v12
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from yahoo_search_api_v12.configuration import Configuration


class AccountTrackingUrl(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'account_id': 'int',
        'account_name': 'str',
        'disapproval_reason_codes': 'list[str]',
        'disapproval_review_url': 'str',
        'in_review_url': 'str',
        'tracking_url': 'str',
        'url_approval_status': 'AccountTrackingUrlServiceUrlApprovalStatus'
    }

    attribute_map = {
        'account_id': 'accountId',
        'account_name': 'accountName',
        'disapproval_reason_codes': 'disapprovalReasonCodes',
        'disapproval_review_url': 'disapprovalReviewUrl',
        'in_review_url': 'inReviewUrl',
        'tracking_url': 'trackingUrl',
        'url_approval_status': 'urlApprovalStatus'
    }

    def __init__(self, account_id=None, account_name=None, disapproval_reason_codes=None, disapproval_review_url=None, in_review_url=None, tracking_url=None, url_approval_status=None, local_vars_configuration=None):  # noqa: E501
        """AccountTrackingUrl - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._account_id = None
        self._account_name = None
        self._disapproval_reason_codes = None
        self._disapproval_review_url = None
        self._in_review_url = None
        self._tracking_url = None
        self._url_approval_status = None
        self.discriminator = None

        self.account_id = account_id
        self.account_name = account_name
        self.disapproval_reason_codes = disapproval_reason_codes
        self.disapproval_review_url = disapproval_review_url
        self.in_review_url = in_review_url
        self.tracking_url = tracking_url
        self.url_approval_status = url_approval_status

    @property
    def account_id(self):
        """Gets the account_id of this AccountTrackingUrl.  # noqa: E501

        <div lang=\"ja\">アカウントIDです。<br> SET時、このフィールドは必須となります。</div> <div lang=\"en\">Account ID.<br> This field is required in SET operation.</div>   # noqa: E501

        :return: The account_id of this AccountTrackingUrl.  # noqa: E501
        :rtype: int
        """
        return self._account_id

    @account_id.setter
    def account_id(self, account_id):
        """Sets the account_id of this AccountTrackingUrl.

        <div lang=\"ja\">アカウントIDです。<br> SET時、このフィールドは必須となります。</div> <div lang=\"en\">Account ID.<br> This field is required in SET operation.</div>   # noqa: E501

        :param account_id: The account_id of this AccountTrackingUrl.  # noqa: E501
        :type: int
        """

        self._account_id = account_id

    @property
    def account_name(self):
        """Gets the account_name of this AccountTrackingUrl.  # noqa: E501

        <div lang=\"ja\">アカウント名です。</div> <div lang=\"en\">Account name.</div>   # noqa: E501

        :return: The account_name of this AccountTrackingUrl.  # noqa: E501
        :rtype: str
        """
        return self._account_name

    @account_name.setter
    def account_name(self, account_name):
        """Sets the account_name of this AccountTrackingUrl.

        <div lang=\"ja\">アカウント名です。</div> <div lang=\"en\">Account name.</div>   # noqa: E501

        :param account_name: The account_name of this AccountTrackingUrl.  # noqa: E501
        :type: str
        """

        self._account_name = account_name

    @property
    def disapproval_reason_codes(self):
        """Gets the disapproval_reason_codes of this AccountTrackingUrl.  # noqa: E501

        <div lang=\"ja\">審査否認理由コードです。</div> <div lang=\"en\">Code of disapproval reason.</div>   # noqa: E501

        :return: The disapproval_reason_codes of this AccountTrackingUrl.  # noqa: E501
        :rtype: list[str]
        """
        return self._disapproval_reason_codes

    @disapproval_reason_codes.setter
    def disapproval_reason_codes(self, disapproval_reason_codes):
        """Sets the disapproval_reason_codes of this AccountTrackingUrl.

        <div lang=\"ja\">審査否認理由コードです。</div> <div lang=\"en\">Code of disapproval reason.</div>   # noqa: E501

        :param disapproval_reason_codes: The disapproval_reason_codes of this AccountTrackingUrl.  # noqa: E501
        :type: list[str]
        """

        self._disapproval_reason_codes = disapproval_reason_codes

    @property
    def disapproval_review_url(self):
        """Gets the disapproval_review_url of this AccountTrackingUrl.  # noqa: E501

        <div lang=\"ja\">審査否認されたトラッキングURLです。</div> <div lang=\"en\">Tracking URL that has been disapproved.</div>   # noqa: E501

        :return: The disapproval_review_url of this AccountTrackingUrl.  # noqa: E501
        :rtype: str
        """
        return self._disapproval_review_url

    @disapproval_review_url.setter
    def disapproval_review_url(self, disapproval_review_url):
        """Sets the disapproval_review_url of this AccountTrackingUrl.

        <div lang=\"ja\">審査否認されたトラッキングURLです。</div> <div lang=\"en\">Tracking URL that has been disapproved.</div>   # noqa: E501

        :param disapproval_review_url: The disapproval_review_url of this AccountTrackingUrl.  # noqa: E501
        :type: str
        """

        self._disapproval_review_url = disapproval_review_url

    @property
    def in_review_url(self):
        """Gets the in_review_url of this AccountTrackingUrl.  # noqa: E501

        <div lang=\"ja\">審査中のトラッキングURLです。</div> <div lang=\"en\">Tracking URL that is in review.</div>   # noqa: E501

        :return: The in_review_url of this AccountTrackingUrl.  # noqa: E501
        :rtype: str
        """
        return self._in_review_url

    @in_review_url.setter
    def in_review_url(self, in_review_url):
        """Sets the in_review_url of this AccountTrackingUrl.

        <div lang=\"ja\">審査中のトラッキングURLです。</div> <div lang=\"en\">Tracking URL that is in review.</div>   # noqa: E501

        :param in_review_url: The in_review_url of this AccountTrackingUrl.  # noqa: E501
        :type: str
        """

        self._in_review_url = in_review_url

    @property
    def tracking_url(self):
        """Gets the tracking_url of this AccountTrackingUrl.  # noqa: E501

        <div lang=\"ja\">トラッキングURLです。<br> SET時、このフィールドは省略可能となります。<br> ※空で設定すると、既存のトラッキングURLは削除されます。</div> <div lang=\"en\">Tracking URL.<br> this field is optional in SET operation.<br> *When tag is set blank, existing Tracking URL will be deleted.</div>   # noqa: E501

        :return: The tracking_url of this AccountTrackingUrl.  # noqa: E501
        :rtype: str
        """
        return self._tracking_url

    @tracking_url.setter
    def tracking_url(self, tracking_url):
        """Sets the tracking_url of this AccountTrackingUrl.

        <div lang=\"ja\">トラッキングURLです。<br> SET時、このフィールドは省略可能となります。<br> ※空で設定すると、既存のトラッキングURLは削除されます。</div> <div lang=\"en\">Tracking URL.<br> this field is optional in SET operation.<br> *When tag is set blank, existing Tracking URL will be deleted.</div>   # noqa: E501

        :param tracking_url: The tracking_url of this AccountTrackingUrl.  # noqa: E501
        :type: str
        """

        self._tracking_url = tracking_url

    @property
    def url_approval_status(self):
        """Gets the url_approval_status of this AccountTrackingUrl.  # noqa: E501


        :return: The url_approval_status of this AccountTrackingUrl.  # noqa: E501
        :rtype: AccountTrackingUrlServiceUrlApprovalStatus
        """
        return self._url_approval_status

    @url_approval_status.setter
    def url_approval_status(self, url_approval_status):
        """Sets the url_approval_status of this AccountTrackingUrl.


        :param url_approval_status: The url_approval_status of this AccountTrackingUrl.  # noqa: E501
        :type: AccountTrackingUrlServiceUrlApprovalStatus
        """

        self._url_approval_status = url_approval_status

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, AccountTrackingUrl):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, AccountTrackingUrl):
            return True

        return self.to_dict() != other.to_dict()
