# coding: utf-8

"""
    Yahoo!広告 検索広告 API リファレンス / Yahoo! JAPAN Ads Search Ads API Reference

    <div lang=\"ja\">Yahoo!広告 検索広告 APIのWebサービスについて説明します。</div> <div lang=\"en\">Search Ads API Web Services supported in Yahoo! JAPAN Ads API.</div> <div><a target=\"_blank\" href=\"https://github.com/yahoojp-marketing/ads-search-api-documents/blob/master/design/v12/Route.yaml\">OpenAPI Specification</a></div> <div lang=\"ja\"><a target=\"_blank\" href=\"https://github.com/yahoojp-marketing/ads-search-api-documents/blob/master/bestpractice/ja\">Best Practice</a></div> <div lang=\"en\"><a target=\"_blank\" href=\"https://github.com/yahoojp-marketing/ads-search-api-documents/blob/master/bestpractice/en\">Best Practice</a></div>   # noqa: E501

    The version of the OpenAPI document: v12
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from yahoo_search_api_v12.configuration import Configuration


class AdGroupAssetServiceList(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'ad_group_assets': 'list[AdGroupAsset]',
        'ad_group_id': 'int',
        'campaign_id': 'int',
        'type': 'AdGroupAssetServiceType'
    }

    attribute_map = {
        'ad_group_assets': 'adGroupAssets',
        'ad_group_id': 'adGroupId',
        'campaign_id': 'campaignId',
        'type': 'type'
    }

    def __init__(self, ad_group_assets=None, ad_group_id=None, campaign_id=None, type=None, local_vars_configuration=None):  # noqa: E501
        """AdGroupAssetServiceList - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._ad_group_assets = None
        self._ad_group_id = None
        self._campaign_id = None
        self._type = None
        self.discriminator = None

        self.ad_group_assets = ad_group_assets
        self.ad_group_id = ad_group_id
        self.campaign_id = campaign_id
        self.type = type

    @property
    def ad_group_assets(self):
        """Gets the ad_group_assets of this AdGroupAssetServiceList.  # noqa: E501


        :return: The ad_group_assets of this AdGroupAssetServiceList.  # noqa: E501
        :rtype: list[AdGroupAsset]
        """
        return self._ad_group_assets

    @ad_group_assets.setter
    def ad_group_assets(self, ad_group_assets):
        """Sets the ad_group_assets of this AdGroupAssetServiceList.


        :param ad_group_assets: The ad_group_assets of this AdGroupAssetServiceList.  # noqa: E501
        :type: list[AdGroupAsset]
        """

        self._ad_group_assets = ad_group_assets

    @property
    def ad_group_id(self):
        """Gets the ad_group_id of this AdGroupAssetServiceList.  # noqa: E501

        <div lang=\"ja\">広告グループIDです。<br> REPLACE時、このフィールドは必須となります。</div> <div lang=\"en\">Ad group ID.<br> This field is required in REPLACE operation.</div>   # noqa: E501

        :return: The ad_group_id of this AdGroupAssetServiceList.  # noqa: E501
        :rtype: int
        """
        return self._ad_group_id

    @ad_group_id.setter
    def ad_group_id(self, ad_group_id):
        """Sets the ad_group_id of this AdGroupAssetServiceList.

        <div lang=\"ja\">広告グループIDです。<br> REPLACE時、このフィールドは必須となります。</div> <div lang=\"en\">Ad group ID.<br> This field is required in REPLACE operation.</div>   # noqa: E501

        :param ad_group_id: The ad_group_id of this AdGroupAssetServiceList.  # noqa: E501
        :type: int
        """

        self._ad_group_id = ad_group_id

    @property
    def campaign_id(self):
        """Gets the campaign_id of this AdGroupAssetServiceList.  # noqa: E501

        <div lang=\"ja\">キャンペーンIDです。<br> REPLACE時、このフィールドは必須となります。</div> <div lang=\"en\">Campaign ID.<br> This field is required in REPLACE operation.</div>   # noqa: E501

        :return: The campaign_id of this AdGroupAssetServiceList.  # noqa: E501
        :rtype: int
        """
        return self._campaign_id

    @campaign_id.setter
    def campaign_id(self, campaign_id):
        """Sets the campaign_id of this AdGroupAssetServiceList.

        <div lang=\"ja\">キャンペーンIDです。<br> REPLACE時、このフィールドは必須となります。</div> <div lang=\"en\">Campaign ID.<br> This field is required in REPLACE operation.</div>   # noqa: E501

        :param campaign_id: The campaign_id of this AdGroupAssetServiceList.  # noqa: E501
        :type: int
        """

        self._campaign_id = campaign_id

    @property
    def type(self):
        """Gets the type of this AdGroupAssetServiceList.  # noqa: E501


        :return: The type of this AdGroupAssetServiceList.  # noqa: E501
        :rtype: AdGroupAssetServiceType
        """
        return self._type

    @type.setter
    def type(self, type):
        """Sets the type of this AdGroupAssetServiceList.


        :param type: The type of this AdGroupAssetServiceList.  # noqa: E501
        :type: AdGroupAssetServiceType
        """

        self._type = type

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, AdGroupAssetServiceList):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, AdGroupAssetServiceList):
            return True

        return self.to_dict() != other.to_dict()
