# coding: utf-8

"""
    Yahoo!広告 検索広告 API リファレンス / Yahoo! JAPAN Ads Search Ads API Reference

    <div lang=\"ja\">Yahoo!広告 検索広告 APIのWebサービスについて説明します。</div> <div lang=\"en\">Search Ads API Web Services supported in Yahoo! JAPAN Ads API.</div> <div><a target=\"_blank\" href=\"https://github.com/yahoojp-marketing/ads-search-api-documents/blob/master/design/v12/Route.yaml\">OpenAPI Specification</a></div> <div lang=\"ja\"><a target=\"_blank\" href=\"https://github.com/yahoojp-marketing/ads-search-api-documents/blob/master/bestpractice/ja\">Best Practice</a></div> <div lang=\"en\"><a target=\"_blank\" href=\"https://github.com/yahoojp-marketing/ads-search-api-documents/blob/master/bestpractice/en\">Best Practice</a></div>   # noqa: E501

    The version of the OpenAPI document: v12
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from yahoo_search_api_v12.configuration import Configuration


class AdGroupCriterionServiceBid(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'ad_group_cpc': 'int',
        'bid_source': 'AdGroupCriterionServiceBidSource',
        'keyword_cpc': 'int',
        'cpc': 'int'
    }

    attribute_map = {
        'ad_group_cpc': 'adGroupCpc',
        'bid_source': 'bidSource',
        'keyword_cpc': 'keywordCpc',
        'cpc': 'cpc'
    }

    def __init__(self, ad_group_cpc=None, bid_source=None, keyword_cpc=None, cpc=None, local_vars_configuration=None):  # noqa: E501
        """AdGroupCriterionServiceBid - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._ad_group_cpc = None
        self._bid_source = None
        self._keyword_cpc = None
        self._cpc = None
        self.discriminator = None

        self.ad_group_cpc = ad_group_cpc
        self.bid_source = bid_source
        self.keyword_cpc = keyword_cpc
        self.cpc = cpc

    @property
    def ad_group_cpc(self):
        """Gets the ad_group_cpc of this AdGroupCriterionServiceBid.  # noqa: E501

        <div lang=\"ja\">広告グループ入札価格です。</div> <div lang=\"en\">CPC of Ad group.</div>   # noqa: E501

        :return: The ad_group_cpc of this AdGroupCriterionServiceBid.  # noqa: E501
        :rtype: int
        """
        return self._ad_group_cpc

    @ad_group_cpc.setter
    def ad_group_cpc(self, ad_group_cpc):
        """Sets the ad_group_cpc of this AdGroupCriterionServiceBid.

        <div lang=\"ja\">広告グループ入札価格です。</div> <div lang=\"en\">CPC of Ad group.</div>   # noqa: E501

        :param ad_group_cpc: The ad_group_cpc of this AdGroupCriterionServiceBid.  # noqa: E501
        :type: int
        """

        self._ad_group_cpc = ad_group_cpc

    @property
    def bid_source(self):
        """Gets the bid_source of this AdGroupCriterionServiceBid.  # noqa: E501


        :return: The bid_source of this AdGroupCriterionServiceBid.  # noqa: E501
        :rtype: AdGroupCriterionServiceBidSource
        """
        return self._bid_source

    @bid_source.setter
    def bid_source(self, bid_source):
        """Sets the bid_source of this AdGroupCriterionServiceBid.


        :param bid_source: The bid_source of this AdGroupCriterionServiceBid.  # noqa: E501
        :type: AdGroupCriterionServiceBidSource
        """

        self._bid_source = bid_source

    @property
    def keyword_cpc(self):
        """Gets the keyword_cpc of this AdGroupCriterionServiceBid.  # noqa: E501

        <div lang=\"ja\">キーワード入札価格です。</div> <div lang=\"en\">CPC of Keyword.</div>   # noqa: E501

        :return: The keyword_cpc of this AdGroupCriterionServiceBid.  # noqa: E501
        :rtype: int
        """
        return self._keyword_cpc

    @keyword_cpc.setter
    def keyword_cpc(self, keyword_cpc):
        """Sets the keyword_cpc of this AdGroupCriterionServiceBid.

        <div lang=\"ja\">キーワード入札価格です。</div> <div lang=\"en\">CPC of Keyword.</div>   # noqa: E501

        :param keyword_cpc: The keyword_cpc of this AdGroupCriterionServiceBid.  # noqa: E501
        :type: int
        """

        self._keyword_cpc = keyword_cpc

    @property
    def cpc(self):
        """Gets the cpc of this AdGroupCriterionServiceBid.  # noqa: E501

        <div lang=\"ja\">キーワード入札価格です。<br> このフィールドは、省略可能となります。その際、ADD時のデフォルト設定値は1となります。<br> ※cpcが0の場合は、設定なしと同様です。</div> <div lang=\"en\">CPC of Keyword.<br> This field is optional. The default value in ADD operation will be 1.<br> *Confirmed as no setting, if value is set &#34;0&#34;.</div>   # noqa: E501

        :return: The cpc of this AdGroupCriterionServiceBid.  # noqa: E501
        :rtype: int
        """
        return self._cpc

    @cpc.setter
    def cpc(self, cpc):
        """Sets the cpc of this AdGroupCriterionServiceBid.

        <div lang=\"ja\">キーワード入札価格です。<br> このフィールドは、省略可能となります。その際、ADD時のデフォルト設定値は1となります。<br> ※cpcが0の場合は、設定なしと同様です。</div> <div lang=\"en\">CPC of Keyword.<br> This field is optional. The default value in ADD operation will be 1.<br> *Confirmed as no setting, if value is set &#34;0&#34;.</div>   # noqa: E501

        :param cpc: The cpc of this AdGroupCriterionServiceBid.  # noqa: E501
        :type: int
        """

        self._cpc = cpc

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, AdGroupCriterionServiceBid):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, AdGroupCriterionServiceBid):
            return True

        return self.to_dict() != other.to_dict()
