# coding: utf-8

"""
    Yahoo!広告 検索広告 API リファレンス / Yahoo! JAPAN Ads Search Ads API Reference

    <div lang=\"ja\">Yahoo!広告 検索広告 APIのWebサービスについて説明します。</div> <div lang=\"en\">Search Ads API Web Services supported in Yahoo! JAPAN Ads API.</div> <div><a target=\"_blank\" href=\"https://github.com/yahoojp-marketing/ads-search-api-documents/blob/master/design/v12/Route.yaml\">OpenAPI Specification</a></div> <div lang=\"ja\"><a target=\"_blank\" href=\"https://github.com/yahoojp-marketing/ads-search-api-documents/blob/master/bestpractice/ja\">Best Practice</a></div> <div lang=\"en\"><a target=\"_blank\" href=\"https://github.com/yahoojp-marketing/ads-search-api-documents/blob/master/bestpractice/en\">Best Practice</a></div>   # noqa: E501

    The version of the OpenAPI document: v12
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from yahoo_search_api_v12.configuration import Configuration


class AdGroupRetargetingList(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'account_id': 'int',
        'ad_group_id': 'int',
        'ad_group_name': 'str',
        'bid_multiplier': 'float',
        'campaign_id': 'int',
        'campaign_name': 'str',
        'criterion_target_list': 'AdGroupRetargetingListServiceCriterionTargetList',
        'excluded_type': 'AdGroupRetargetingListServiceExcludedType'
    }

    attribute_map = {
        'account_id': 'accountId',
        'ad_group_id': 'adGroupId',
        'ad_group_name': 'adGroupName',
        'bid_multiplier': 'bidMultiplier',
        'campaign_id': 'campaignId',
        'campaign_name': 'campaignName',
        'criterion_target_list': 'criterionTargetList',
        'excluded_type': 'excludedType'
    }

    def __init__(self, account_id=None, ad_group_id=None, ad_group_name=None, bid_multiplier=None, campaign_id=None, campaign_name=None, criterion_target_list=None, excluded_type=None, local_vars_configuration=None):  # noqa: E501
        """AdGroupRetargetingList - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._account_id = None
        self._ad_group_id = None
        self._ad_group_name = None
        self._bid_multiplier = None
        self._campaign_id = None
        self._campaign_name = None
        self._criterion_target_list = None
        self._excluded_type = None
        self.discriminator = None

        self.account_id = account_id
        self.ad_group_id = ad_group_id
        self.ad_group_name = ad_group_name
        self.bid_multiplier = bid_multiplier
        self.campaign_id = campaign_id
        self.campaign_name = campaign_name
        self.criterion_target_list = criterion_target_list
        self.excluded_type = excluded_type

    @property
    def account_id(self):
        """Gets the account_id of this AdGroupRetargetingList.  # noqa: E501

        <div lang=\"ja\">アカウントIDです。<br> このフィールドは、レスポンスの際に返却されますが、リクエストの際には無視されます。</div> <div lang=\"en\">Account ID.<br> Although this field will be returned in the response, it will be ignored on input.</div>   # noqa: E501

        :return: The account_id of this AdGroupRetargetingList.  # noqa: E501
        :rtype: int
        """
        return self._account_id

    @account_id.setter
    def account_id(self, account_id):
        """Sets the account_id of this AdGroupRetargetingList.

        <div lang=\"ja\">アカウントIDです。<br> このフィールドは、レスポンスの際に返却されますが、リクエストの際には無視されます。</div> <div lang=\"en\">Account ID.<br> Although this field will be returned in the response, it will be ignored on input.</div>   # noqa: E501

        :param account_id: The account_id of this AdGroupRetargetingList.  # noqa: E501
        :type: int
        """

        self._account_id = account_id

    @property
    def ad_group_id(self):
        """Gets the ad_group_id of this AdGroupRetargetingList.  # noqa: E501

        <div lang=\"ja\">広告グループIDです。<br> このフィールドは、いずれの場合でも必須です。</div> <div lang=\"en\">Ad group ID.<br> This field is required in any cases.</div>   # noqa: E501

        :return: The ad_group_id of this AdGroupRetargetingList.  # noqa: E501
        :rtype: int
        """
        return self._ad_group_id

    @ad_group_id.setter
    def ad_group_id(self, ad_group_id):
        """Sets the ad_group_id of this AdGroupRetargetingList.

        <div lang=\"ja\">広告グループIDです。<br> このフィールドは、いずれの場合でも必須です。</div> <div lang=\"en\">Ad group ID.<br> This field is required in any cases.</div>   # noqa: E501

        :param ad_group_id: The ad_group_id of this AdGroupRetargetingList.  # noqa: E501
        :type: int
        """

        self._ad_group_id = ad_group_id

    @property
    def ad_group_name(self):
        """Gets the ad_group_name of this AdGroupRetargetingList.  # noqa: E501

        <div lang=\"ja\">広告グループ名です。<br> このフィールドは、レスポンスの際に返却されますが、リクエストの際には無視されます。</div> <div lang=\"en\">Ad group name.<br> Although this field will be returned in the response, it will be ignored on input.</div>   # noqa: E501

        :return: The ad_group_name of this AdGroupRetargetingList.  # noqa: E501
        :rtype: str
        """
        return self._ad_group_name

    @ad_group_name.setter
    def ad_group_name(self, ad_group_name):
        """Sets the ad_group_name of this AdGroupRetargetingList.

        <div lang=\"ja\">広告グループ名です。<br> このフィールドは、レスポンスの際に返却されますが、リクエストの際には無視されます。</div> <div lang=\"en\">Ad group name.<br> Although this field will be returned in the response, it will be ignored on input.</div>   # noqa: E501

        :param ad_group_name: The ad_group_name of this AdGroupRetargetingList.  # noqa: E501
        :type: str
        """

        self._ad_group_name = ad_group_name

    @property
    def bid_multiplier(self):
        """Gets the bid_multiplier of this AdGroupRetargetingList.  # noqa: E501

        <div lang=\"ja\">   CPC上昇値です。<br>   0.10～10.00まで指定できます。<br>   また、0を指定した場合、広告は配信されません。<br>   CPC上昇値の値は小数点第二位まで指定可能です。<br>   このフィールドは省略可能となります。その際、デフォルト設定値は1.0となります。 </div> <div lang=\"en\">   Maximum CPC increase value.<br>   Can be specified between  0.10 to 10.00.<br>   When specified &#39;0&#39;, the ad will not be delivered.<br>   Maximum CPC increase value can be specified up to two decimal places.<br>   This field is optional. The default value will be 1.0. </div>   # noqa: E501

        :return: The bid_multiplier of this AdGroupRetargetingList.  # noqa: E501
        :rtype: float
        """
        return self._bid_multiplier

    @bid_multiplier.setter
    def bid_multiplier(self, bid_multiplier):
        """Sets the bid_multiplier of this AdGroupRetargetingList.

        <div lang=\"ja\">   CPC上昇値です。<br>   0.10～10.00まで指定できます。<br>   また、0を指定した場合、広告は配信されません。<br>   CPC上昇値の値は小数点第二位まで指定可能です。<br>   このフィールドは省略可能となります。その際、デフォルト設定値は1.0となります。 </div> <div lang=\"en\">   Maximum CPC increase value.<br>   Can be specified between  0.10 to 10.00.<br>   When specified &#39;0&#39;, the ad will not be delivered.<br>   Maximum CPC increase value can be specified up to two decimal places.<br>   This field is optional. The default value will be 1.0. </div>   # noqa: E501

        :param bid_multiplier: The bid_multiplier of this AdGroupRetargetingList.  # noqa: E501
        :type: float
        """

        self._bid_multiplier = bid_multiplier

    @property
    def campaign_id(self):
        """Gets the campaign_id of this AdGroupRetargetingList.  # noqa: E501

        <div lang=\"ja\">キャンペーンIDです。<br> このフィールドは、いずれの場合でも必須です。</div> <div lang=\"en\">Campaign ID.<br> This field is required in any cases.</div>   # noqa: E501

        :return: The campaign_id of this AdGroupRetargetingList.  # noqa: E501
        :rtype: int
        """
        return self._campaign_id

    @campaign_id.setter
    def campaign_id(self, campaign_id):
        """Sets the campaign_id of this AdGroupRetargetingList.

        <div lang=\"ja\">キャンペーンIDです。<br> このフィールドは、いずれの場合でも必須です。</div> <div lang=\"en\">Campaign ID.<br> This field is required in any cases.</div>   # noqa: E501

        :param campaign_id: The campaign_id of this AdGroupRetargetingList.  # noqa: E501
        :type: int
        """

        self._campaign_id = campaign_id

    @property
    def campaign_name(self):
        """Gets the campaign_name of this AdGroupRetargetingList.  # noqa: E501

        <div lang=\"ja\">キャンペーン名です。<br> このフィールドは、レスポンスの際に返却されますが、リクエストの際には無視されます。</div> <div lang=\"en\">Campaign name.<br> Although this field will be returned in the response, it will be ignored on input.</div>   # noqa: E501

        :return: The campaign_name of this AdGroupRetargetingList.  # noqa: E501
        :rtype: str
        """
        return self._campaign_name

    @campaign_name.setter
    def campaign_name(self, campaign_name):
        """Sets the campaign_name of this AdGroupRetargetingList.

        <div lang=\"ja\">キャンペーン名です。<br> このフィールドは、レスポンスの際に返却されますが、リクエストの際には無視されます。</div> <div lang=\"en\">Campaign name.<br> Although this field will be returned in the response, it will be ignored on input.</div>   # noqa: E501

        :param campaign_name: The campaign_name of this AdGroupRetargetingList.  # noqa: E501
        :type: str
        """

        self._campaign_name = campaign_name

    @property
    def criterion_target_list(self):
        """Gets the criterion_target_list of this AdGroupRetargetingList.  # noqa: E501


        :return: The criterion_target_list of this AdGroupRetargetingList.  # noqa: E501
        :rtype: AdGroupRetargetingListServiceCriterionTargetList
        """
        return self._criterion_target_list

    @criterion_target_list.setter
    def criterion_target_list(self, criterion_target_list):
        """Sets the criterion_target_list of this AdGroupRetargetingList.


        :param criterion_target_list: The criterion_target_list of this AdGroupRetargetingList.  # noqa: E501
        :type: AdGroupRetargetingListServiceCriterionTargetList
        """

        self._criterion_target_list = criterion_target_list

    @property
    def excluded_type(self):
        """Gets the excluded_type of this AdGroupRetargetingList.  # noqa: E501


        :return: The excluded_type of this AdGroupRetargetingList.  # noqa: E501
        :rtype: AdGroupRetargetingListServiceExcludedType
        """
        return self._excluded_type

    @excluded_type.setter
    def excluded_type(self, excluded_type):
        """Sets the excluded_type of this AdGroupRetargetingList.


        :param excluded_type: The excluded_type of this AdGroupRetargetingList.  # noqa: E501
        :type: AdGroupRetargetingListServiceExcludedType
        """

        self._excluded_type = excluded_type

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, AdGroupRetargetingList):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, AdGroupRetargetingList):
            return True

        return self.to_dict() != other.to_dict()
