# coding: utf-8

"""
    Yahoo!広告 検索広告 API リファレンス / Yahoo! JAPAN Ads Search Ads API Reference

    <div lang=\"ja\">Yahoo!広告 検索広告 APIのWebサービスについて説明します。</div> <div lang=\"en\">Search Ads API Web Services supported in Yahoo! JAPAN Ads API.</div> <div><a target=\"_blank\" href=\"https://github.com/yahoojp-marketing/ads-search-api-documents/blob/master/design/v12/Route.yaml\">OpenAPI Specification</a></div> <div lang=\"ja\"><a target=\"_blank\" href=\"https://github.com/yahoojp-marketing/ads-search-api-documents/blob/master/bestpractice/ja\">Best Practice</a></div> <div lang=\"en\"><a target=\"_blank\" href=\"https://github.com/yahoojp-marketing/ads-search-api-documents/blob/master/bestpractice/en\">Best Practice</a></div>   # noqa: E501

    The version of the OpenAPI document: v12
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from yahoo_search_api_v12.configuration import Configuration


class AdGroupServiceTargetRoasBiddingScheme(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'target_roas': 'float',
        'is_remove_target_roas': 'AdGroupServiceIsRemoveFlg'
    }

    attribute_map = {
        'target_roas': 'targetRoas',
        'is_remove_target_roas': 'isRemoveTargetRoas'
    }

    def __init__(self, target_roas=None, is_remove_target_roas=None, local_vars_configuration=None):  # noqa: E501
        """AdGroupServiceTargetRoasBiddingScheme - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._target_roas = None
        self._is_remove_target_roas = None
        self.discriminator = None

        self.target_roas = target_roas
        self.is_remove_target_roas = is_remove_target_roas

    @property
    def target_roas(self):
        """Gets the target_roas of this AdGroupServiceTargetRoasBiddingScheme.  # noqa: E501

        <div lang=\"ja\"> 広告グループ費用対効果（tROAS）です。<br> ADDおよびSET時、このフィールドは省略可能となります。<br> ※0.01 ～ 1000.00（1% ～ 100000%）の範囲内のみ 許容します。<br> ※campaignBiddingStrategyTypeがTARGET_ROASの場合のみ指定可能です。 </div> <div lang=\"en\"> Target ROAS (tROAS) of ad group.<br> This field is optional in ADD and SET operation.<br> *Limit range: 0.01 - 1000.00 (1% - 100000%)<br> *This can only be specified when campaignBiddingStrategyType is TARGET_ROAS. </div>   # noqa: E501

        :return: The target_roas of this AdGroupServiceTargetRoasBiddingScheme.  # noqa: E501
        :rtype: float
        """
        return self._target_roas

    @target_roas.setter
    def target_roas(self, target_roas):
        """Sets the target_roas of this AdGroupServiceTargetRoasBiddingScheme.

        <div lang=\"ja\"> 広告グループ費用対効果（tROAS）です。<br> ADDおよびSET時、このフィールドは省略可能となります。<br> ※0.01 ～ 1000.00（1% ～ 100000%）の範囲内のみ 許容します。<br> ※campaignBiddingStrategyTypeがTARGET_ROASの場合のみ指定可能です。 </div> <div lang=\"en\"> Target ROAS (tROAS) of ad group.<br> This field is optional in ADD and SET operation.<br> *Limit range: 0.01 - 1000.00 (1% - 100000%)<br> *This can only be specified when campaignBiddingStrategyType is TARGET_ROAS. </div>   # noqa: E501

        :param target_roas: The target_roas of this AdGroupServiceTargetRoasBiddingScheme.  # noqa: E501
        :type: float
        """

        self._target_roas = target_roas

    @property
    def is_remove_target_roas(self):
        """Gets the is_remove_target_roas of this AdGroupServiceTargetRoasBiddingScheme.  # noqa: E501


        :return: The is_remove_target_roas of this AdGroupServiceTargetRoasBiddingScheme.  # noqa: E501
        :rtype: AdGroupServiceIsRemoveFlg
        """
        return self._is_remove_target_roas

    @is_remove_target_roas.setter
    def is_remove_target_roas(self, is_remove_target_roas):
        """Sets the is_remove_target_roas of this AdGroupServiceTargetRoasBiddingScheme.


        :param is_remove_target_roas: The is_remove_target_roas of this AdGroupServiceTargetRoasBiddingScheme.  # noqa: E501
        :type: AdGroupServiceIsRemoveFlg
        """

        self._is_remove_target_roas = is_remove_target_roas

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, AdGroupServiceTargetRoasBiddingScheme):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, AdGroupServiceTargetRoasBiddingScheme):
            return True

        return self.to_dict() != other.to_dict()
