# coding: utf-8

"""
    Yahoo!広告 検索広告 API リファレンス / Yahoo! JAPAN Ads Search Ads API Reference

    <div lang=\"ja\">Yahoo!広告 検索広告 APIのWebサービスについて説明します。</div> <div lang=\"en\">Search Ads API Web Services supported in Yahoo! JAPAN Ads API.</div> <div><a target=\"_blank\" href=\"https://github.com/yahoojp-marketing/ads-search-api-documents/blob/master/design/v12/Route.yaml\">OpenAPI Specification</a></div> <div lang=\"ja\"><a target=\"_blank\" href=\"https://github.com/yahoojp-marketing/ads-search-api-documents/blob/master/bestpractice/ja\">Best Practice</a></div> <div lang=\"en\"><a target=\"_blank\" href=\"https://github.com/yahoojp-marketing/ads-search-api-documents/blob/master/bestpractice/en\">Best Practice</a></div>   # noqa: E501

    The version of the OpenAPI document: v12
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from yahoo_search_api_v12.configuration import Configuration


class AdGroupServiceUrlReviewData(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'disapproval_reason_codes': 'list[str]',
        'disapproval_review_url': 'AdGroupServiceReviewUrl',
        'in_review_url': 'AdGroupServiceReviewUrl',
        'url_approval_status': 'AdGroupServiceUrlApprovalStatus'
    }

    attribute_map = {
        'disapproval_reason_codes': 'disapprovalReasonCodes',
        'disapproval_review_url': 'disapprovalReviewUrl',
        'in_review_url': 'inReviewUrl',
        'url_approval_status': 'urlApprovalStatus'
    }

    def __init__(self, disapproval_reason_codes=None, disapproval_review_url=None, in_review_url=None, url_approval_status=None, local_vars_configuration=None):  # noqa: E501
        """AdGroupServiceUrlReviewData - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._disapproval_reason_codes = None
        self._disapproval_review_url = None
        self._in_review_url = None
        self._url_approval_status = None
        self.discriminator = None

        self.disapproval_reason_codes = disapproval_reason_codes
        self.disapproval_review_url = disapproval_review_url
        self.in_review_url = in_review_url
        self.url_approval_status = url_approval_status

    @property
    def disapproval_reason_codes(self):
        """Gets the disapproval_reason_codes of this AdGroupServiceUrlReviewData.  # noqa: E501

        <div lang=\"ja\">審査否認理由コードです。</div> <div lang=\"en\">Code of Disapproval reason.<br></div>   # noqa: E501

        :return: The disapproval_reason_codes of this AdGroupServiceUrlReviewData.  # noqa: E501
        :rtype: list[str]
        """
        return self._disapproval_reason_codes

    @disapproval_reason_codes.setter
    def disapproval_reason_codes(self, disapproval_reason_codes):
        """Sets the disapproval_reason_codes of this AdGroupServiceUrlReviewData.

        <div lang=\"ja\">審査否認理由コードです。</div> <div lang=\"en\">Code of Disapproval reason.<br></div>   # noqa: E501

        :param disapproval_reason_codes: The disapproval_reason_codes of this AdGroupServiceUrlReviewData.  # noqa: E501
        :type: list[str]
        """

        self._disapproval_reason_codes = disapproval_reason_codes

    @property
    def disapproval_review_url(self):
        """Gets the disapproval_review_url of this AdGroupServiceUrlReviewData.  # noqa: E501


        :return: The disapproval_review_url of this AdGroupServiceUrlReviewData.  # noqa: E501
        :rtype: AdGroupServiceReviewUrl
        """
        return self._disapproval_review_url

    @disapproval_review_url.setter
    def disapproval_review_url(self, disapproval_review_url):
        """Sets the disapproval_review_url of this AdGroupServiceUrlReviewData.


        :param disapproval_review_url: The disapproval_review_url of this AdGroupServiceUrlReviewData.  # noqa: E501
        :type: AdGroupServiceReviewUrl
        """

        self._disapproval_review_url = disapproval_review_url

    @property
    def in_review_url(self):
        """Gets the in_review_url of this AdGroupServiceUrlReviewData.  # noqa: E501


        :return: The in_review_url of this AdGroupServiceUrlReviewData.  # noqa: E501
        :rtype: AdGroupServiceReviewUrl
        """
        return self._in_review_url

    @in_review_url.setter
    def in_review_url(self, in_review_url):
        """Sets the in_review_url of this AdGroupServiceUrlReviewData.


        :param in_review_url: The in_review_url of this AdGroupServiceUrlReviewData.  # noqa: E501
        :type: AdGroupServiceReviewUrl
        """

        self._in_review_url = in_review_url

    @property
    def url_approval_status(self):
        """Gets the url_approval_status of this AdGroupServiceUrlReviewData.  # noqa: E501


        :return: The url_approval_status of this AdGroupServiceUrlReviewData.  # noqa: E501
        :rtype: AdGroupServiceUrlApprovalStatus
        """
        return self._url_approval_status

    @url_approval_status.setter
    def url_approval_status(self, url_approval_status):
        """Sets the url_approval_status of this AdGroupServiceUrlReviewData.


        :param url_approval_status: The url_approval_status of this AdGroupServiceUrlReviewData.  # noqa: E501
        :type: AdGroupServiceUrlApprovalStatus
        """

        self._url_approval_status = url_approval_status

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, AdGroupServiceUrlReviewData):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, AdGroupServiceUrlReviewData):
            return True

        return self.to_dict() != other.to_dict()
