# coding: utf-8

"""
    Yahoo!広告 検索広告 API リファレンス / Yahoo! JAPAN Ads Search Ads API Reference

    <div lang=\"ja\">Yahoo!広告 検索広告 APIのWebサービスについて説明します。</div> <div lang=\"en\">Search Ads API Web Services supported in Yahoo! JAPAN Ads API.</div> <div><a target=\"_blank\" href=\"https://github.com/yahoojp-marketing/ads-search-api-documents/blob/master/design/v12/Route.yaml\">OpenAPI Specification</a></div> <div lang=\"ja\"><a target=\"_blank\" href=\"https://github.com/yahoojp-marketing/ads-search-api-documents/blob/master/bestpractice/ja\">Best Practice</a></div> <div lang=\"en\"><a target=\"_blank\" href=\"https://github.com/yahoojp-marketing/ads-search-api-documents/blob/master/bestpractice/en\">Best Practice</a></div>   # noqa: E501

    The version of the OpenAPI document: v12
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from yahoo_search_api_v12.configuration import Configuration


class AssetServiceCallAsset(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'phone_number': 'str',
        'review_phone_number': 'str',
        'schedules': 'list[AssetServiceSchedule]'
    }

    attribute_map = {
        'phone_number': 'phoneNumber',
        'review_phone_number': 'reviewPhoneNumber',
        'schedules': 'schedules'
    }

    def __init__(self, phone_number=None, review_phone_number=None, schedules=None, local_vars_configuration=None):  # noqa: E501
        """AssetServiceCallAsset - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._phone_number = None
        self._review_phone_number = None
        self._schedules = None
        self.discriminator = None

        self.phone_number = phone_number
        self.review_phone_number = review_phone_number
        self.schedules = schedules

    @property
    def phone_number(self):
        """Gets the phone_number of this AssetServiceCallAsset.  # noqa: E501

        <div lang=\"ja\">電話番号です。<br> ADDおよびSET時、このフィールドは必須となります。</div> <div lang=\"en\">Phone number.<br> This field is required in ADD and SET operation.</div>   # noqa: E501

        :return: The phone_number of this AssetServiceCallAsset.  # noqa: E501
        :rtype: str
        """
        return self._phone_number

    @phone_number.setter
    def phone_number(self, phone_number):
        """Sets the phone_number of this AssetServiceCallAsset.

        <div lang=\"ja\">電話番号です。<br> ADDおよびSET時、このフィールドは必須となります。</div> <div lang=\"en\">Phone number.<br> This field is required in ADD and SET operation.</div>   # noqa: E501

        :param phone_number: The phone_number of this AssetServiceCallAsset.  # noqa: E501
        :type: str
        """

        self._phone_number = phone_number

    @property
    def review_phone_number(self):
        """Gets the review_phone_number of this AssetServiceCallAsset.  # noqa: E501

        <div lang=\"ja\">審査中の電話番号です。<br> このフィールドは、リクエストの際には無視されます。<br> 審査中の間のみ、レスポンスの際に返却されます。</div> <div lang=\"en\">Phone number on editorial review.<br> This field will be ignored on input.<br> It will be returned at the time of response only during the review.</div>   # noqa: E501

        :return: The review_phone_number of this AssetServiceCallAsset.  # noqa: E501
        :rtype: str
        """
        return self._review_phone_number

    @review_phone_number.setter
    def review_phone_number(self, review_phone_number):
        """Sets the review_phone_number of this AssetServiceCallAsset.

        <div lang=\"ja\">審査中の電話番号です。<br> このフィールドは、リクエストの際には無視されます。<br> 審査中の間のみ、レスポンスの際に返却されます。</div> <div lang=\"en\">Phone number on editorial review.<br> This field will be ignored on input.<br> It will be returned at the time of response only during the review.</div>   # noqa: E501

        :param review_phone_number: The review_phone_number of this AssetServiceCallAsset.  # noqa: E501
        :type: str
        """

        self._review_phone_number = review_phone_number

    @property
    def schedules(self):
        """Gets the schedules of this AssetServiceCallAsset.  # noqa: E501


        :return: The schedules of this AssetServiceCallAsset.  # noqa: E501
        :rtype: list[AssetServiceSchedule]
        """
        return self._schedules

    @schedules.setter
    def schedules(self, schedules):
        """Sets the schedules of this AssetServiceCallAsset.


        :param schedules: The schedules of this AssetServiceCallAsset.  # noqa: E501
        :type: list[AssetServiceSchedule]
        """

        self._schedules = schedules

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, AssetServiceCallAsset):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, AssetServiceCallAsset):
            return True

        return self.to_dict() != other.to_dict()
