# coding: utf-8

"""
    Yahoo!広告 検索広告 API リファレンス / Yahoo! JAPAN Ads Search Ads API Reference

    <div lang=\"ja\">Yahoo!広告 検索広告 APIのWebサービスについて説明します。</div> <div lang=\"en\">Search Ads API Web Services supported in Yahoo! JAPAN Ads API.</div> <div><a target=\"_blank\" href=\"https://github.com/yahoojp-marketing/ads-search-api-documents/blob/master/design/v12/Route.yaml\">OpenAPI Specification</a></div> <div lang=\"ja\"><a target=\"_blank\" href=\"https://github.com/yahoojp-marketing/ads-search-api-documents/blob/master/bestpractice/ja\">Best Practice</a></div> <div lang=\"en\"><a target=\"_blank\" href=\"https://github.com/yahoojp-marketing/ads-search-api-documents/blob/master/bestpractice/en\">Best Practice</a></div>   # noqa: E501

    The version of the OpenAPI document: v12
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from yahoo_search_api_v12.configuration import Configuration


class AssetServiceCalloutAsset(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'callout_text': 'str',
        'review_callout_text': 'str',
        'start_date': 'str',
        'end_date': 'str',
        'schedules': 'list[AssetServiceSchedule]'
    }

    attribute_map = {
        'callout_text': 'calloutText',
        'review_callout_text': 'reviewCalloutText',
        'start_date': 'startDate',
        'end_date': 'endDate',
        'schedules': 'schedules'
    }

    def __init__(self, callout_text=None, review_callout_text=None, start_date=None, end_date=None, schedules=None, local_vars_configuration=None):  # noqa: E501
        """AssetServiceCalloutAsset - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._callout_text = None
        self._review_callout_text = None
        self._start_date = None
        self._end_date = None
        self._schedules = None
        self.discriminator = None

        self.callout_text = callout_text
        self.review_callout_text = review_callout_text
        self.start_date = start_date
        self.end_date = end_date
        self.schedules = schedules

    @property
    def callout_text(self):
        """Gets the callout_text of this AssetServiceCalloutAsset.  # noqa: E501

        <div lang=\"ja\">コールアウトテキストです。<br> ADDおよびSET時、このフィールドは必須となります。</div> <div lang=\"en\">Callout text.<br> This field is required in ADD and SET operation.</div>   # noqa: E501

        :return: The callout_text of this AssetServiceCalloutAsset.  # noqa: E501
        :rtype: str
        """
        return self._callout_text

    @callout_text.setter
    def callout_text(self, callout_text):
        """Sets the callout_text of this AssetServiceCalloutAsset.

        <div lang=\"ja\">コールアウトテキストです。<br> ADDおよびSET時、このフィールドは必須となります。</div> <div lang=\"en\">Callout text.<br> This field is required in ADD and SET operation.</div>   # noqa: E501

        :param callout_text: The callout_text of this AssetServiceCalloutAsset.  # noqa: E501
        :type: str
        """

        self._callout_text = callout_text

    @property
    def review_callout_text(self):
        """Gets the review_callout_text of this AssetServiceCalloutAsset.  # noqa: E501

        <div lang=\"ja\">審査中のコールアウトテキストです。<br> このフィールドは、リクエストの際には無視されます。<br> 審査中の間のみ、レスポンスの際に返却されます。</div> <div lang=\"en\">Callout text on editorial review.<br> This field will be ignored on input.<br> It will be returned at the time of response only during the review.</div>   # noqa: E501

        :return: The review_callout_text of this AssetServiceCalloutAsset.  # noqa: E501
        :rtype: str
        """
        return self._review_callout_text

    @review_callout_text.setter
    def review_callout_text(self, review_callout_text):
        """Sets the review_callout_text of this AssetServiceCalloutAsset.

        <div lang=\"ja\">審査中のコールアウトテキストです。<br> このフィールドは、リクエストの際には無視されます。<br> 審査中の間のみ、レスポンスの際に返却されます。</div> <div lang=\"en\">Callout text on editorial review.<br> This field will be ignored on input.<br> It will be returned at the time of response only during the review.</div>   # noqa: E501

        :param review_callout_text: The review_callout_text of this AssetServiceCalloutAsset.  # noqa: E501
        :type: str
        """

        self._review_callout_text = review_callout_text

    @property
    def start_date(self):
        """Gets the start_date of this AssetServiceCalloutAsset.  # noqa: E501

        <div lang=\"ja\">配信開始日です。<br> ※空で設定すると、既存の配信開始日は削除されます。<br> このフィールドは、ADDおよびSET時に省略可能となり、REMOVE時に無視されます。</div> <div lang=\"en\">Start date of ad display<br> *On setting blank, existing start date of ad display will be deleted.<br> This field is optional in ADD and SET operation, and will be ignored in REMOVE operation.</div>   # noqa: E501

        :return: The start_date of this AssetServiceCalloutAsset.  # noqa: E501
        :rtype: str
        """
        return self._start_date

    @start_date.setter
    def start_date(self, start_date):
        """Sets the start_date of this AssetServiceCalloutAsset.

        <div lang=\"ja\">配信開始日です。<br> ※空で設定すると、既存の配信開始日は削除されます。<br> このフィールドは、ADDおよびSET時に省略可能となり、REMOVE時に無視されます。</div> <div lang=\"en\">Start date of ad display<br> *On setting blank, existing start date of ad display will be deleted.<br> This field is optional in ADD and SET operation, and will be ignored in REMOVE operation.</div>   # noqa: E501

        :param start_date: The start_date of this AssetServiceCalloutAsset.  # noqa: E501
        :type: str
        """

        self._start_date = start_date

    @property
    def end_date(self):
        """Gets the end_date of this AssetServiceCalloutAsset.  # noqa: E501

        <div lang=\"ja\">配信終了日です。<br> ※空で設定すると、既存の配信終了日は削除されます。<br> このフィールドは、ADDおよびSET時に省略可能となり、REMOVE時に無視されます。</div> <div lang=\"en\">End date of ad display.<br> *By setting blank, existing end date of ad display will be deleted.<br> This field is optional in ADD and SET operation, and will be ignored in REMOVE operation.</div>   # noqa: E501

        :return: The end_date of this AssetServiceCalloutAsset.  # noqa: E501
        :rtype: str
        """
        return self._end_date

    @end_date.setter
    def end_date(self, end_date):
        """Sets the end_date of this AssetServiceCalloutAsset.

        <div lang=\"ja\">配信終了日です。<br> ※空で設定すると、既存の配信終了日は削除されます。<br> このフィールドは、ADDおよびSET時に省略可能となり、REMOVE時に無視されます。</div> <div lang=\"en\">End date of ad display.<br> *By setting blank, existing end date of ad display will be deleted.<br> This field is optional in ADD and SET operation, and will be ignored in REMOVE operation.</div>   # noqa: E501

        :param end_date: The end_date of this AssetServiceCalloutAsset.  # noqa: E501
        :type: str
        """

        self._end_date = end_date

    @property
    def schedules(self):
        """Gets the schedules of this AssetServiceCalloutAsset.  # noqa: E501


        :return: The schedules of this AssetServiceCalloutAsset.  # noqa: E501
        :rtype: list[AssetServiceSchedule]
        """
        return self._schedules

    @schedules.setter
    def schedules(self, schedules):
        """Sets the schedules of this AssetServiceCalloutAsset.


        :param schedules: The schedules of this AssetServiceCalloutAsset.  # noqa: E501
        :type: list[AssetServiceSchedule]
        """

        self._schedules = schedules

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, AssetServiceCalloutAsset):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, AssetServiceCalloutAsset):
            return True

        return self.to_dict() != other.to_dict()
