# coding: utf-8

"""
    Yahoo!広告 検索広告 API リファレンス / Yahoo! JAPAN Ads Search Ads API Reference

    <div lang=\"ja\">Yahoo!広告 検索広告 APIのWebサービスについて説明します。</div> <div lang=\"en\">Search Ads API Web Services supported in Yahoo! JAPAN Ads API.</div> <div><a target=\"_blank\" href=\"https://github.com/yahoojp-marketing/ads-search-api-documents/blob/master/design/v12/Route.yaml\">OpenAPI Specification</a></div> <div lang=\"ja\"><a target=\"_blank\" href=\"https://github.com/yahoojp-marketing/ads-search-api-documents/blob/master/bestpractice/ja\">Best Practice</a></div> <div lang=\"en\"><a target=\"_blank\" href=\"https://github.com/yahoojp-marketing/ads-search-api-documents/blob/master/bestpractice/en\">Best Practice</a></div>   # noqa: E501

    The version of the OpenAPI document: v12
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from yahoo_search_api_v12.configuration import Configuration


class BiddingStrategyServiceTargetImpressionShareScheme(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'location': 'BiddingStrategyServiceTargetImpressionShareLocation',
        'bid_ceiling': 'int',
        'target_impression_share': 'int'
    }

    attribute_map = {
        'location': 'location',
        'bid_ceiling': 'bidCeiling',
        'target_impression_share': 'targetImpressionShare'
    }

    def __init__(self, location=None, bid_ceiling=None, target_impression_share=None, local_vars_configuration=None):  # noqa: E501
        """BiddingStrategyServiceTargetImpressionShareScheme - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._location = None
        self._bid_ceiling = None
        self._target_impression_share = None
        self.discriminator = None

        self.location = location
        self.bid_ceiling = bid_ceiling
        self.target_impression_share = target_impression_share

    @property
    def location(self):
        """Gets the location of this BiddingStrategyServiceTargetImpressionShareScheme.  # noqa: E501


        :return: The location of this BiddingStrategyServiceTargetImpressionShareScheme.  # noqa: E501
        :rtype: BiddingStrategyServiceTargetImpressionShareLocation
        """
        return self._location

    @location.setter
    def location(self, location):
        """Sets the location of this BiddingStrategyServiceTargetImpressionShareScheme.


        :param location: The location of this BiddingStrategyServiceTargetImpressionShareScheme.  # noqa: E501
        :type: BiddingStrategyServiceTargetImpressionShareLocation
        """

        self._location = location

    @property
    def bid_ceiling(self):
        """Gets the bid_ceiling of this BiddingStrategyServiceTargetImpressionShareScheme.  # noqa: E501

        <div lang=\"ja\">入札価格の上限です。（0〜50000）<br> ※「0」が設定された場合、上限設定はありません。<br> このフィールドは、いずれの場合でも省略可能となります。</div> <div lang=\"en\">CPC limit (0-50000).<br> * No limits if &#34;0&#34; is set.<br> This field is optional in any cases.</div>   # noqa: E501

        :return: The bid_ceiling of this BiddingStrategyServiceTargetImpressionShareScheme.  # noqa: E501
        :rtype: int
        """
        return self._bid_ceiling

    @bid_ceiling.setter
    def bid_ceiling(self, bid_ceiling):
        """Sets the bid_ceiling of this BiddingStrategyServiceTargetImpressionShareScheme.

        <div lang=\"ja\">入札価格の上限です。（0〜50000）<br> ※「0」が設定された場合、上限設定はありません。<br> このフィールドは、いずれの場合でも省略可能となります。</div> <div lang=\"en\">CPC limit (0-50000).<br> * No limits if &#34;0&#34; is set.<br> This field is optional in any cases.</div>   # noqa: E501

        :param bid_ceiling: The bid_ceiling of this BiddingStrategyServiceTargetImpressionShareScheme.  # noqa: E501
        :type: int
        """

        self._bid_ceiling = bid_ceiling

    @property
    def target_impression_share(self):
        """Gets the target_impression_share of this BiddingStrategyServiceTargetImpressionShareScheme.  # noqa: E501

        <div lang=\"ja\">目標のインプレッションシェアです。<br> ADD時およびSET時、このフィールドは必須となります。</div> <div lang=\"en\">Target impression share.<br> This field is required in ADD and SET operation. </div>   # noqa: E501

        :return: The target_impression_share of this BiddingStrategyServiceTargetImpressionShareScheme.  # noqa: E501
        :rtype: int
        """
        return self._target_impression_share

    @target_impression_share.setter
    def target_impression_share(self, target_impression_share):
        """Sets the target_impression_share of this BiddingStrategyServiceTargetImpressionShareScheme.

        <div lang=\"ja\">目標のインプレッションシェアです。<br> ADD時およびSET時、このフィールドは必須となります。</div> <div lang=\"en\">Target impression share.<br> This field is required in ADD and SET operation. </div>   # noqa: E501

        :param target_impression_share: The target_impression_share of this BiddingStrategyServiceTargetImpressionShareScheme.  # noqa: E501
        :type: int
        """

        self._target_impression_share = target_impression_share

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, BiddingStrategyServiceTargetImpressionShareScheme):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, BiddingStrategyServiceTargetImpressionShareScheme):
            return True

        return self.to_dict() != other.to_dict()
