# coding: utf-8

"""
    Yahoo!広告 検索広告 API リファレンス / Yahoo! JAPAN Ads Search Ads API Reference

    <div lang=\"ja\">Yahoo!広告 検索広告 APIのWebサービスについて説明します。</div> <div lang=\"en\">Search Ads API Web Services supported in Yahoo! JAPAN Ads API.</div> <div><a target=\"_blank\" href=\"https://github.com/yahoojp-marketing/ads-search-api-documents/blob/master/design/v12/Route.yaml\">OpenAPI Specification</a></div> <div lang=\"ja\"><a target=\"_blank\" href=\"https://github.com/yahoojp-marketing/ads-search-api-documents/blob/master/bestpractice/ja\">Best Practice</a></div> <div lang=\"en\"><a target=\"_blank\" href=\"https://github.com/yahoojp-marketing/ads-search-api-documents/blob/master/bestpractice/en\">Best Practice</a></div>   # noqa: E501

    The version of the OpenAPI document: v12
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from yahoo_search_api_v12.configuration import Configuration


class CampaignBudget(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'account_id': 'int',
        'campaign_budget_id': 'int',
        'campaign_budget_name': 'str',
        'amount': 'int'
    }

    attribute_map = {
        'account_id': 'accountId',
        'campaign_budget_id': 'campaignBudgetId',
        'campaign_budget_name': 'campaignBudgetName',
        'amount': 'amount'
    }

    def __init__(self, account_id=None, campaign_budget_id=None, campaign_budget_name=None, amount=None, local_vars_configuration=None):  # noqa: E501
        """CampaignBudget - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._account_id = None
        self._campaign_budget_id = None
        self._campaign_budget_name = None
        self._amount = None
        self.discriminator = None

        self.account_id = account_id
        self.campaign_budget_id = campaign_budget_id
        self.campaign_budget_name = campaign_budget_name
        self.amount = amount

    @property
    def account_id(self):
        """Gets the account_id of this CampaignBudget.  # noqa: E501

        <div lang=\"ja\">アカウントIDです。<br> このフィールドは、レスポンスの際に返却されますが、リクエストの際には無視されます。</div> <div lang=\"en\">Account ID.<br> Although this field will be returned in the response, it will be ignored on input.</div>   # noqa: E501

        :return: The account_id of this CampaignBudget.  # noqa: E501
        :rtype: int
        """
        return self._account_id

    @account_id.setter
    def account_id(self, account_id):
        """Sets the account_id of this CampaignBudget.

        <div lang=\"ja\">アカウントIDです。<br> このフィールドは、レスポンスの際に返却されますが、リクエストの際には無視されます。</div> <div lang=\"en\">Account ID.<br> Although this field will be returned in the response, it will be ignored on input.</div>   # noqa: E501

        :param account_id: The account_id of this CampaignBudget.  # noqa: E501
        :type: int
        """

        self._account_id = account_id

    @property
    def campaign_budget_id(self):
        """Gets the campaign_budget_id of this CampaignBudget.  # noqa: E501

        <div lang=\"ja\">共有予算IDです。<br> このフィールドは、SETおよびREMOVE時に必須となり、ADD時に無視されます。</div> <div lang=\"en\">CampaignBudget ID.<br>This field is required in SET and REMOVE operation, and will be ignored in ADD operation.</div>   # noqa: E501

        :return: The campaign_budget_id of this CampaignBudget.  # noqa: E501
        :rtype: int
        """
        return self._campaign_budget_id

    @campaign_budget_id.setter
    def campaign_budget_id(self, campaign_budget_id):
        """Sets the campaign_budget_id of this CampaignBudget.

        <div lang=\"ja\">共有予算IDです。<br> このフィールドは、SETおよびREMOVE時に必須となり、ADD時に無視されます。</div> <div lang=\"en\">CampaignBudget ID.<br>This field is required in SET and REMOVE operation, and will be ignored in ADD operation.</div>   # noqa: E501

        :param campaign_budget_id: The campaign_budget_id of this CampaignBudget.  # noqa: E501
        :type: int
        """

        self._campaign_budget_id = campaign_budget_id

    @property
    def campaign_budget_name(self):
        """Gets the campaign_budget_name of this CampaignBudget.  # noqa: E501

        <div lang=\"ja\">共有予算名です。<br>このフィールドは、ADD時に必須となり、SET時に省略可能となります。</div> <div lang=\"en\">CampaignBudget name.<br>This field is required in ADD operation, and will be optional in SET operation.</div>   # noqa: E501

        :return: The campaign_budget_name of this CampaignBudget.  # noqa: E501
        :rtype: str
        """
        return self._campaign_budget_name

    @campaign_budget_name.setter
    def campaign_budget_name(self, campaign_budget_name):
        """Sets the campaign_budget_name of this CampaignBudget.

        <div lang=\"ja\">共有予算名です。<br>このフィールドは、ADD時に必須となり、SET時に省略可能となります。</div> <div lang=\"en\">CampaignBudget name.<br>This field is required in ADD operation, and will be optional in SET operation.</div>   # noqa: E501

        :param campaign_budget_name: The campaign_budget_name of this CampaignBudget.  # noqa: E501
        :type: str
        """

        self._campaign_budget_name = campaign_budget_name

    @property
    def amount(self):
        """Gets the amount of this CampaignBudget.  # noqa: E501

        <div lang=\"ja\">共有予算の金額です。<br> このフィールドは、ADD時は必須となり、SET時は省略可能となります。</div> <div lang=\"en\">Amount of budget of Campaign.<br> This field is required in ADD operation, and is optional in SET operation.</div>   # noqa: E501

        :return: The amount of this CampaignBudget.  # noqa: E501
        :rtype: int
        """
        return self._amount

    @amount.setter
    def amount(self, amount):
        """Sets the amount of this CampaignBudget.

        <div lang=\"ja\">共有予算の金額です。<br> このフィールドは、ADD時は必須となり、SET時は省略可能となります。</div> <div lang=\"en\">Amount of budget of Campaign.<br> This field is required in ADD operation, and is optional in SET operation.</div>   # noqa: E501

        :param amount: The amount of this CampaignBudget.  # noqa: E501
        :type: int
        """

        self._amount = amount

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, CampaignBudget):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, CampaignBudget):
            return True

        return self.to_dict() != other.to_dict()
