# coding: utf-8

"""
    Yahoo!広告 検索広告 API リファレンス / Yahoo! JAPAN Ads Search Ads API Reference

    <div lang=\"ja\">Yahoo!広告 検索広告 APIのWebサービスについて説明します。</div> <div lang=\"en\">Search Ads API Web Services supported in Yahoo! JAPAN Ads API.</div> <div><a target=\"_blank\" href=\"https://github.com/yahoojp-marketing/ads-search-api-documents/blob/master/design/v12/Route.yaml\">OpenAPI Specification</a></div> <div lang=\"ja\"><a target=\"_blank\" href=\"https://github.com/yahoojp-marketing/ads-search-api-documents/blob/master/bestpractice/ja\">Best Practice</a></div> <div lang=\"en\"><a target=\"_blank\" href=\"https://github.com/yahoojp-marketing/ads-search-api-documents/blob/master/bestpractice/en\">Best Practice</a></div>   # noqa: E501

    The version of the OpenAPI document: v12
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from yahoo_search_api_v12.configuration import Configuration


class CampaignCriterion(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'account_id': 'int',
        'campaign_id': 'int',
        'campaign_name': 'str',
        'criterion': 'CampaignCriterionServiceCriterion',
        'use': 'CampaignCriterionServiceUse'
    }

    attribute_map = {
        'account_id': 'accountId',
        'campaign_id': 'campaignId',
        'campaign_name': 'campaignName',
        'criterion': 'criterion',
        'use': 'use'
    }

    def __init__(self, account_id=None, campaign_id=None, campaign_name=None, criterion=None, use=None, local_vars_configuration=None):  # noqa: E501
        """CampaignCriterion - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._account_id = None
        self._campaign_id = None
        self._campaign_name = None
        self._criterion = None
        self._use = None
        self.discriminator = None

        self.account_id = account_id
        self.campaign_id = campaign_id
        self.campaign_name = campaign_name
        self.criterion = criterion
        self.use = use

    @property
    def account_id(self):
        """Gets the account_id of this CampaignCriterion.  # noqa: E501

        <div lang=\"ja\">アカウントIDです。<br> ADD時およびREMOVE時、このフィールドは必須です。</div> <div lang=\"en\">Account ID.<br> This field is required in ADD and REMOVE operation.</div>   # noqa: E501

        :return: The account_id of this CampaignCriterion.  # noqa: E501
        :rtype: int
        """
        return self._account_id

    @account_id.setter
    def account_id(self, account_id):
        """Sets the account_id of this CampaignCriterion.

        <div lang=\"ja\">アカウントIDです。<br> ADD時およびREMOVE時、このフィールドは必須です。</div> <div lang=\"en\">Account ID.<br> This field is required in ADD and REMOVE operation.</div>   # noqa: E501

        :param account_id: The account_id of this CampaignCriterion.  # noqa: E501
        :type: int
        """

        self._account_id = account_id

    @property
    def campaign_id(self):
        """Gets the campaign_id of this CampaignCriterion.  # noqa: E501

        <div lang=\"ja\">キャンペーンIDです。<br> ADD時およびREMOVE時、このフィールドは必須です。</div> <div lang=\"en\">Campaign ID.<br> This field is required in ADD and REMOVE operation.</div>   # noqa: E501

        :return: The campaign_id of this CampaignCriterion.  # noqa: E501
        :rtype: int
        """
        return self._campaign_id

    @campaign_id.setter
    def campaign_id(self, campaign_id):
        """Sets the campaign_id of this CampaignCriterion.

        <div lang=\"ja\">キャンペーンIDです。<br> ADD時およびREMOVE時、このフィールドは必須です。</div> <div lang=\"en\">Campaign ID.<br> This field is required in ADD and REMOVE operation.</div>   # noqa: E501

        :param campaign_id: The campaign_id of this CampaignCriterion.  # noqa: E501
        :type: int
        """

        self._campaign_id = campaign_id

    @property
    def campaign_name(self):
        """Gets the campaign_name of this CampaignCriterion.  # noqa: E501

        <div lang=\"ja\">キャンペーン名です。<br> このフィールドは、レスポンスの際に返却されますが、リクエストの際には無視されます。</div> <div lang=\"en\">Campaign name.<br> Although this field will be returned in the response, it will be ignored on input.</div>   # noqa: E501

        :return: The campaign_name of this CampaignCriterion.  # noqa: E501
        :rtype: str
        """
        return self._campaign_name

    @campaign_name.setter
    def campaign_name(self, campaign_name):
        """Sets the campaign_name of this CampaignCriterion.

        <div lang=\"ja\">キャンペーン名です。<br> このフィールドは、レスポンスの際に返却されますが、リクエストの際には無視されます。</div> <div lang=\"en\">Campaign name.<br> Although this field will be returned in the response, it will be ignored on input.</div>   # noqa: E501

        :param campaign_name: The campaign_name of this CampaignCriterion.  # noqa: E501
        :type: str
        """

        self._campaign_name = campaign_name

    @property
    def criterion(self):
        """Gets the criterion of this CampaignCriterion.  # noqa: E501


        :return: The criterion of this CampaignCriterion.  # noqa: E501
        :rtype: CampaignCriterionServiceCriterion
        """
        return self._criterion

    @criterion.setter
    def criterion(self, criterion):
        """Sets the criterion of this CampaignCriterion.


        :param criterion: The criterion of this CampaignCriterion.  # noqa: E501
        :type: CampaignCriterionServiceCriterion
        """

        self._criterion = criterion

    @property
    def use(self):
        """Gets the use of this CampaignCriterion.  # noqa: E501


        :return: The use of this CampaignCriterion.  # noqa: E501
        :rtype: CampaignCriterionServiceUse
        """
        return self._use

    @use.setter
    def use(self, use):
        """Sets the use of this CampaignCriterion.


        :param use: The use of this CampaignCriterion.  # noqa: E501
        :type: CampaignCriterionServiceUse
        """

        self._use = use

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, CampaignCriterion):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, CampaignCriterion):
            return True

        return self.to_dict() != other.to_dict()
