# coding: utf-8

"""
    Yahoo!広告 検索広告 API リファレンス / Yahoo! JAPAN Ads Search Ads API Reference

    <div lang=\"ja\">Yahoo!広告 検索広告 APIのWebサービスについて説明します。</div> <div lang=\"en\">Search Ads API Web Services supported in Yahoo! JAPAN Ads API.</div> <div><a target=\"_blank\" href=\"https://github.com/yahoojp-marketing/ads-search-api-documents/blob/master/design/v12/Route.yaml\">OpenAPI Specification</a></div> <div lang=\"ja\"><a target=\"_blank\" href=\"https://github.com/yahoojp-marketing/ads-search-api-documents/blob/master/bestpractice/ja\">Best Practice</a></div> <div lang=\"en\"><a target=\"_blank\" href=\"https://github.com/yahoojp-marketing/ads-search-api-documents/blob/master/bestpractice/en\">Best Practice</a></div>   # noqa: E501

    The version of the OpenAPI document: v12
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from yahoo_search_api_v12.configuration import Configuration


class CampaignSharedSet(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'account_id': 'int',
        'campaign_id': 'int',
        'campaign_name': 'str',
        'shared_list_id': 'int',
        'shared_list_name': 'str'
    }

    attribute_map = {
        'account_id': 'accountId',
        'campaign_id': 'campaignId',
        'campaign_name': 'campaignName',
        'shared_list_id': 'sharedListId',
        'shared_list_name': 'sharedListName'
    }

    def __init__(self, account_id=None, campaign_id=None, campaign_name=None, shared_list_id=None, shared_list_name=None, local_vars_configuration=None):  # noqa: E501
        """CampaignSharedSet - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._account_id = None
        self._campaign_id = None
        self._campaign_name = None
        self._shared_list_id = None
        self._shared_list_name = None
        self.discriminator = None

        self.account_id = account_id
        self.campaign_id = campaign_id
        self.campaign_name = campaign_name
        self.shared_list_id = shared_list_id
        self.shared_list_name = shared_list_name

    @property
    def account_id(self):
        """Gets the account_id of this CampaignSharedSet.  # noqa: E501

        <div lang=\"ja\">アカウントIDです。</div> <div lang=\"en\">Account ID.</div>   # noqa: E501

        :return: The account_id of this CampaignSharedSet.  # noqa: E501
        :rtype: int
        """
        return self._account_id

    @account_id.setter
    def account_id(self, account_id):
        """Sets the account_id of this CampaignSharedSet.

        <div lang=\"ja\">アカウントIDです。</div> <div lang=\"en\">Account ID.</div>   # noqa: E501

        :param account_id: The account_id of this CampaignSharedSet.  # noqa: E501
        :type: int
        """

        self._account_id = account_id

    @property
    def campaign_id(self):
        """Gets the campaign_id of this CampaignSharedSet.  # noqa: E501

        <div lang=\"ja\">キャンペーンIDです。<br> ADD時およびREMOVE時、このフィールドは必須です。</div> <div lang=\"en\">Campaign ID.<br> This field is required in ADD and REMOVE operation.</div>   # noqa: E501

        :return: The campaign_id of this CampaignSharedSet.  # noqa: E501
        :rtype: int
        """
        return self._campaign_id

    @campaign_id.setter
    def campaign_id(self, campaign_id):
        """Sets the campaign_id of this CampaignSharedSet.

        <div lang=\"ja\">キャンペーンIDです。<br> ADD時およびREMOVE時、このフィールドは必須です。</div> <div lang=\"en\">Campaign ID.<br> This field is required in ADD and REMOVE operation.</div>   # noqa: E501

        :param campaign_id: The campaign_id of this CampaignSharedSet.  # noqa: E501
        :type: int
        """

        self._campaign_id = campaign_id

    @property
    def campaign_name(self):
        """Gets the campaign_name of this CampaignSharedSet.  # noqa: E501

        <div lang=\"ja\">キャンペーン名です。</div> <div lang=\"en\">Campaign name.</div>   # noqa: E501

        :return: The campaign_name of this CampaignSharedSet.  # noqa: E501
        :rtype: str
        """
        return self._campaign_name

    @campaign_name.setter
    def campaign_name(self, campaign_name):
        """Sets the campaign_name of this CampaignSharedSet.

        <div lang=\"ja\">キャンペーン名です。</div> <div lang=\"en\">Campaign name.</div>   # noqa: E501

        :param campaign_name: The campaign_name of this CampaignSharedSet.  # noqa: E501
        :type: str
        """

        self._campaign_name = campaign_name

    @property
    def shared_list_id(self):
        """Gets the shared_list_id of this CampaignSharedSet.  # noqa: E501

        <div lang=\"ja\">アカウントの対象外キーワードリストIDです。<br> ADD時およびREMOVE時、このフィールドは必須です。</div> <div lang=\"en\">Negative keyword list ID of the account.<br> This field is required in ADD and REMOVE operation.</div>   # noqa: E501

        :return: The shared_list_id of this CampaignSharedSet.  # noqa: E501
        :rtype: int
        """
        return self._shared_list_id

    @shared_list_id.setter
    def shared_list_id(self, shared_list_id):
        """Sets the shared_list_id of this CampaignSharedSet.

        <div lang=\"ja\">アカウントの対象外キーワードリストIDです。<br> ADD時およびREMOVE時、このフィールドは必須です。</div> <div lang=\"en\">Negative keyword list ID of the account.<br> This field is required in ADD and REMOVE operation.</div>   # noqa: E501

        :param shared_list_id: The shared_list_id of this CampaignSharedSet.  # noqa: E501
        :type: int
        """

        self._shared_list_id = shared_list_id

    @property
    def shared_list_name(self):
        """Gets the shared_list_name of this CampaignSharedSet.  # noqa: E501

        <div lang=\"ja\">アカウントの対象外キーワードリスト名です。</div> <div lang=\"en\">Negative keyword list name of the account.</div>   # noqa: E501

        :return: The shared_list_name of this CampaignSharedSet.  # noqa: E501
        :rtype: str
        """
        return self._shared_list_name

    @shared_list_name.setter
    def shared_list_name(self, shared_list_name):
        """Sets the shared_list_name of this CampaignSharedSet.

        <div lang=\"ja\">アカウントの対象外キーワードリスト名です。</div> <div lang=\"en\">Negative keyword list name of the account.</div>   # noqa: E501

        :param shared_list_name: The shared_list_name of this CampaignSharedSet.  # noqa: E501
        :type: str
        """

        self._shared_list_name = shared_list_name

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, CampaignSharedSet):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, CampaignSharedSet):
            return True

        return self.to_dict() != other.to_dict()
