# coding: utf-8

"""
    Yahoo!広告 検索広告 API リファレンス / Yahoo! JAPAN Ads Search Ads API Reference

    <div lang=\"ja\">Yahoo!広告 検索広告 APIのWebサービスについて説明します。</div> <div lang=\"en\">Search Ads API Web Services supported in Yahoo! JAPAN Ads API.</div> <div><a target=\"_blank\" href=\"https://github.com/yahoojp-marketing/ads-search-api-documents/blob/master/design/v12/Route.yaml\">OpenAPI Specification</a></div> <div lang=\"ja\"><a target=\"_blank\" href=\"https://github.com/yahoojp-marketing/ads-search-api-documents/blob/master/bestpractice/ja\">Best Practice</a></div> <div lang=\"en\"><a target=\"_blank\" href=\"https://github.com/yahoojp-marketing/ads-search-api-documents/blob/master/bestpractice/en\">Best Practice</a></div>   # noqa: E501

    The version of the OpenAPI document: v12
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from yahoo_search_api_v12.configuration import Configuration


class CampaignTargetServiceSelector(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'account_id': 'int',
        'campaign_ids': 'list[int]',
        'excluded_type': 'CampaignTargetServiceExcludedType',
        'number_results': 'int',
        'platform_types': 'list[CampaignTargetServicePlatformType]',
        'start_index': 'int',
        'target_ids': 'list[str]',
        'target_types': 'list[CampaignTargetServiceTargetType]'
    }

    attribute_map = {
        'account_id': 'accountId',
        'campaign_ids': 'campaignIds',
        'excluded_type': 'excludedType',
        'number_results': 'numberResults',
        'platform_types': 'platformTypes',
        'start_index': 'startIndex',
        'target_ids': 'targetIds',
        'target_types': 'targetTypes'
    }

    def __init__(self, account_id=None, campaign_ids=None, excluded_type=None, number_results=500, platform_types=None, start_index=1, target_ids=None, target_types=None, local_vars_configuration=None):  # noqa: E501
        """CampaignTargetServiceSelector - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._account_id = None
        self._campaign_ids = None
        self._excluded_type = None
        self._number_results = None
        self._platform_types = None
        self._start_index = None
        self._target_ids = None
        self._target_types = None
        self.discriminator = None

        self.account_id = account_id
        self.campaign_ids = campaign_ids
        self.excluded_type = excluded_type
        self.number_results = number_results
        self.platform_types = platform_types
        self.start_index = start_index
        self.target_ids = target_ids
        self.target_types = target_types

    @property
    def account_id(self):
        """Gets the account_id of this CampaignTargetServiceSelector.  # noqa: E501

        <div lang=\"ja\">アカウントIDです。</div> <div lang=\"en\">Account ID.</div>   # noqa: E501

        :return: The account_id of this CampaignTargetServiceSelector.  # noqa: E501
        :rtype: int
        """
        return self._account_id

    @account_id.setter
    def account_id(self, account_id):
        """Sets the account_id of this CampaignTargetServiceSelector.

        <div lang=\"ja\">アカウントIDです。</div> <div lang=\"en\">Account ID.</div>   # noqa: E501

        :param account_id: The account_id of this CampaignTargetServiceSelector.  # noqa: E501
        :type: int
        """
        if self.local_vars_configuration.client_side_validation and account_id is None:  # noqa: E501
            raise ValueError("Invalid value for `account_id`, must not be `None`")  # noqa: E501

        self._account_id = account_id

    @property
    def campaign_ids(self):
        """Gets the campaign_ids of this CampaignTargetServiceSelector.  # noqa: E501

        <div lang=\"ja\">キャンペーンIDです。</div> <div lang=\"en\">Campaign ID.</div>   # noqa: E501

        :return: The campaign_ids of this CampaignTargetServiceSelector.  # noqa: E501
        :rtype: list[int]
        """
        return self._campaign_ids

    @campaign_ids.setter
    def campaign_ids(self, campaign_ids):
        """Sets the campaign_ids of this CampaignTargetServiceSelector.

        <div lang=\"ja\">キャンペーンIDです。</div> <div lang=\"en\">Campaign ID.</div>   # noqa: E501

        :param campaign_ids: The campaign_ids of this CampaignTargetServiceSelector.  # noqa: E501
        :type: list[int]
        """

        self._campaign_ids = campaign_ids

    @property
    def excluded_type(self):
        """Gets the excluded_type of this CampaignTargetServiceSelector.  # noqa: E501


        :return: The excluded_type of this CampaignTargetServiceSelector.  # noqa: E501
        :rtype: CampaignTargetServiceExcludedType
        """
        return self._excluded_type

    @excluded_type.setter
    def excluded_type(self, excluded_type):
        """Sets the excluded_type of this CampaignTargetServiceSelector.


        :param excluded_type: The excluded_type of this CampaignTargetServiceSelector.  # noqa: E501
        :type: CampaignTargetServiceExcludedType
        """

        self._excluded_type = excluded_type

    @property
    def number_results(self):
        """Gets the number_results of this CampaignTargetServiceSelector.  # noqa: E501

        <div lang=\"ja\">ページの最大件数です。このフィールドは、1以上を指定する必要があります。</div> <div lang=\"en\">Maximum number of results to return in this page. This field must be greater than or equal to 1. Also see Entity Limits per operation.</div>   # noqa: E501

        :return: The number_results of this CampaignTargetServiceSelector.  # noqa: E501
        :rtype: int
        """
        return self._number_results

    @number_results.setter
    def number_results(self, number_results):
        """Sets the number_results of this CampaignTargetServiceSelector.

        <div lang=\"ja\">ページの最大件数です。このフィールドは、1以上を指定する必要があります。</div> <div lang=\"en\">Maximum number of results to return in this page. This field must be greater than or equal to 1. Also see Entity Limits per operation.</div>   # noqa: E501

        :param number_results: The number_results of this CampaignTargetServiceSelector.  # noqa: E501
        :type: int
        """
        if (self.local_vars_configuration.client_side_validation and
                number_results is not None and number_results > 500):  # noqa: E501
            raise ValueError("Invalid value for `number_results`, must be a value less than or equal to `500`")  # noqa: E501
        if (self.local_vars_configuration.client_side_validation and
                number_results is not None and number_results < 1):  # noqa: E501
            raise ValueError("Invalid value for `number_results`, must be a value greater than or equal to `1`")  # noqa: E501

        self._number_results = number_results

    @property
    def platform_types(self):
        """Gets the platform_types of this CampaignTargetServiceSelector.  # noqa: E501


        :return: The platform_types of this CampaignTargetServiceSelector.  # noqa: E501
        :rtype: list[CampaignTargetServicePlatformType]
        """
        return self._platform_types

    @platform_types.setter
    def platform_types(self, platform_types):
        """Sets the platform_types of this CampaignTargetServiceSelector.


        :param platform_types: The platform_types of this CampaignTargetServiceSelector.  # noqa: E501
        :type: list[CampaignTargetServicePlatformType]
        """

        self._platform_types = platform_types

    @property
    def start_index(self):
        """Gets the start_index of this CampaignTargetServiceSelector.  # noqa: E501

        <div lang=\"ja\">ページの先頭のインデックスです。このフィールドは、1以上を指定する必要があります。</div> <div lang=\"en\">Index of the first result to return in this page. This field must be greater than or equal to 1.</div>   # noqa: E501

        :return: The start_index of this CampaignTargetServiceSelector.  # noqa: E501
        :rtype: int
        """
        return self._start_index

    @start_index.setter
    def start_index(self, start_index):
        """Sets the start_index of this CampaignTargetServiceSelector.

        <div lang=\"ja\">ページの先頭のインデックスです。このフィールドは、1以上を指定する必要があります。</div> <div lang=\"en\">Index of the first result to return in this page. This field must be greater than or equal to 1.</div>   # noqa: E501

        :param start_index: The start_index of this CampaignTargetServiceSelector.  # noqa: E501
        :type: int
        """
        if (self.local_vars_configuration.client_side_validation and
                start_index is not None and start_index < 1):  # noqa: E501
            raise ValueError("Invalid value for `start_index`, must be a value greater than or equal to `1`")  # noqa: E501

        self._start_index = start_index

    @property
    def target_ids(self):
        """Gets the target_ids of this CampaignTargetServiceSelector.  # noqa: E501

        <div lang=\"ja\">ターゲットIDです。</div> <div lang=\"en\">Target ID.</div>   # noqa: E501

        :return: The target_ids of this CampaignTargetServiceSelector.  # noqa: E501
        :rtype: list[str]
        """
        return self._target_ids

    @target_ids.setter
    def target_ids(self, target_ids):
        """Sets the target_ids of this CampaignTargetServiceSelector.

        <div lang=\"ja\">ターゲットIDです。</div> <div lang=\"en\">Target ID.</div>   # noqa: E501

        :param target_ids: The target_ids of this CampaignTargetServiceSelector.  # noqa: E501
        :type: list[str]
        """

        self._target_ids = target_ids

    @property
    def target_types(self):
        """Gets the target_types of this CampaignTargetServiceSelector.  # noqa: E501


        :return: The target_types of this CampaignTargetServiceSelector.  # noqa: E501
        :rtype: list[CampaignTargetServiceTargetType]
        """
        return self._target_types

    @target_types.setter
    def target_types(self, target_types):
        """Sets the target_types of this CampaignTargetServiceSelector.


        :param target_types: The target_types of this CampaignTargetServiceSelector.  # noqa: E501
        :type: list[CampaignTargetServiceTargetType]
        """

        self._target_types = target_types

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, CampaignTargetServiceSelector):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, CampaignTargetServiceSelector):
            return True

        return self.to_dict() != other.to_dict()
