# coding: utf-8

"""
    Yahoo!広告 検索広告 API リファレンス / Yahoo! JAPAN Ads Search Ads API Reference

    <div lang=\"ja\">Yahoo!広告 検索広告 APIのWebサービスについて説明します。</div> <div lang=\"en\">Search Ads API Web Services supported in Yahoo! JAPAN Ads API.</div> <div><a target=\"_blank\" href=\"https://github.com/yahoojp-marketing/ads-search-api-documents/blob/master/design/v12/Route.yaml\">OpenAPI Specification</a></div> <div lang=\"ja\"><a target=\"_blank\" href=\"https://github.com/yahoojp-marketing/ads-search-api-documents/blob/master/bestpractice/ja\">Best Practice</a></div> <div lang=\"en\"><a target=\"_blank\" href=\"https://github.com/yahoojp-marketing/ads-search-api-documents/blob/master/bestpractice/en\">Best Practice</a></div>   # noqa: E501

    The version of the OpenAPI document: v12
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from yahoo_search_api_v12.configuration import Configuration


class ConversionTrackerServiceWebConversion(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'markup_language': 'ConversionTrackerServiceMarkupLanguage',
        'advanced_snippet': 'str',
        'tracking_code_type': 'ConversionTrackerServiceTrackingCodeType'
    }

    attribute_map = {
        'markup_language': 'markupLanguage',
        'advanced_snippet': 'advancedSnippet',
        'tracking_code_type': 'trackingCodeType'
    }

    def __init__(self, markup_language=None, advanced_snippet=None, tracking_code_type=None, local_vars_configuration=None):  # noqa: E501
        """ConversionTrackerServiceWebConversion - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._markup_language = None
        self._advanced_snippet = None
        self._tracking_code_type = None
        self.discriminator = None

        self.markup_language = markup_language
        self.advanced_snippet = advanced_snippet
        self.tracking_code_type = tracking_code_type

    @property
    def markup_language(self):
        """Gets the markup_language of this ConversionTrackerServiceWebConversion.  # noqa: E501


        :return: The markup_language of this ConversionTrackerServiceWebConversion.  # noqa: E501
        :rtype: ConversionTrackerServiceMarkupLanguage
        """
        return self._markup_language

    @markup_language.setter
    def markup_language(self, markup_language):
        """Sets the markup_language of this ConversionTrackerServiceWebConversion.


        :param markup_language: The markup_language of this ConversionTrackerServiceWebConversion.  # noqa: E501
        :type: ConversionTrackerServiceMarkupLanguage
        """

        self._markup_language = markup_language

    @property
    def advanced_snippet(self):
        """Gets the advanced_snippet of this ConversionTrackerServiceWebConversion.  # noqa: E501

        <div lang=\"ja\">   リニューアル版のコンバージョンタグは、従来のタグよりもブラウザーなどの環境の影響を受けづらい新しいフォーマットです。<br>   詳細は以下のヘルプを参照してください。<br>   ・<a href=\"https://ads-help.yahoo-net.jp/s/article/H000045014?language=ja\">コンバージョン測定とは</a><br>   このフィールドは、レスポンスの際に返却されますが、リクエストの際には無視されます。 </div> <div lang=\"en\">   The new format of conversion tag avoids the impacts such as changes made to the browser. <br>   See also the help below.<br>   * <a href=\"https://ads-help.yahoo-net.jp/s/article/H000045014?language=en_US\">Conversion Analytics</a><br>   Although this field will be returned in the response, it will be ignored on input. </div>   # noqa: E501

        :return: The advanced_snippet of this ConversionTrackerServiceWebConversion.  # noqa: E501
        :rtype: str
        """
        return self._advanced_snippet

    @advanced_snippet.setter
    def advanced_snippet(self, advanced_snippet):
        """Sets the advanced_snippet of this ConversionTrackerServiceWebConversion.

        <div lang=\"ja\">   リニューアル版のコンバージョンタグは、従来のタグよりもブラウザーなどの環境の影響を受けづらい新しいフォーマットです。<br>   詳細は以下のヘルプを参照してください。<br>   ・<a href=\"https://ads-help.yahoo-net.jp/s/article/H000045014?language=ja\">コンバージョン測定とは</a><br>   このフィールドは、レスポンスの際に返却されますが、リクエストの際には無視されます。 </div> <div lang=\"en\">   The new format of conversion tag avoids the impacts such as changes made to the browser. <br>   See also the help below.<br>   * <a href=\"https://ads-help.yahoo-net.jp/s/article/H000045014?language=en_US\">Conversion Analytics</a><br>   Although this field will be returned in the response, it will be ignored on input. </div>   # noqa: E501

        :param advanced_snippet: The advanced_snippet of this ConversionTrackerServiceWebConversion.  # noqa: E501
        :type: str
        """

        self._advanced_snippet = advanced_snippet

    @property
    def tracking_code_type(self):
        """Gets the tracking_code_type of this ConversionTrackerServiceWebConversion.  # noqa: E501


        :return: The tracking_code_type of this ConversionTrackerServiceWebConversion.  # noqa: E501
        :rtype: ConversionTrackerServiceTrackingCodeType
        """
        return self._tracking_code_type

    @tracking_code_type.setter
    def tracking_code_type(self, tracking_code_type):
        """Sets the tracking_code_type of this ConversionTrackerServiceWebConversion.


        :param tracking_code_type: The tracking_code_type of this ConversionTrackerServiceWebConversion.  # noqa: E501
        :type: ConversionTrackerServiceTrackingCodeType
        """

        self._tracking_code_type = tracking_code_type

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ConversionTrackerServiceWebConversion):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, ConversionTrackerServiceWebConversion):
            return True

        return self.to_dict() != other.to_dict()
