# coding: utf-8

"""
    Yahoo!広告 検索広告 API リファレンス / Yahoo! JAPAN Ads Search Ads API Reference

    <div lang=\"ja\">Yahoo!広告 検索広告 APIのWebサービスについて説明します。</div> <div lang=\"en\">Search Ads API Web Services supported in Yahoo! JAPAN Ads API.</div> <div><a target=\"_blank\" href=\"https://github.com/yahoojp-marketing/ads-search-api-documents/blob/master/design/v12/Route.yaml\">OpenAPI Specification</a></div> <div lang=\"ja\"><a target=\"_blank\" href=\"https://github.com/yahoojp-marketing/ads-search-api-documents/blob/master/bestpractice/ja\">Best Practice</a></div> <div lang=\"en\"><a target=\"_blank\" href=\"https://github.com/yahoojp-marketing/ads-search-api-documents/blob/master/bestpractice/en\">Best Practice</a></div>   # noqa: E501

    The version of the OpenAPI document: v12
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from yahoo_search_api_v12.configuration import Configuration


class DictionaryServiceAppLinkVendor(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'app_vendor_id': 'str',
        'app_vendor_name_ja': 'str',
        'app_vendor_name_en': 'str'
    }

    attribute_map = {
        'app_vendor_id': 'appVendorId',
        'app_vendor_name_ja': 'appVendorNameJa',
        'app_vendor_name_en': 'appVendorNameEn'
    }

    def __init__(self, app_vendor_id=None, app_vendor_name_ja=None, app_vendor_name_en=None, local_vars_configuration=None):  # noqa: E501
        """DictionaryServiceAppLinkVendor - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._app_vendor_id = None
        self._app_vendor_name_ja = None
        self._app_vendor_name_en = None
        self.discriminator = None

        self.app_vendor_id = app_vendor_id
        self.app_vendor_name_ja = app_vendor_name_ja
        self.app_vendor_name_en = app_vendor_name_en

    @property
    def app_vendor_id(self):
        """Gets the app_vendor_id of this DictionaryServiceAppLinkVendor.  # noqa: E501

        <div lang=\"ja\">アプリ計測ベンダーIDです。</div> <div lang=\"en\">App vendor ID.</div>   # noqa: E501

        :return: The app_vendor_id of this DictionaryServiceAppLinkVendor.  # noqa: E501
        :rtype: str
        """
        return self._app_vendor_id

    @app_vendor_id.setter
    def app_vendor_id(self, app_vendor_id):
        """Sets the app_vendor_id of this DictionaryServiceAppLinkVendor.

        <div lang=\"ja\">アプリ計測ベンダーIDです。</div> <div lang=\"en\">App vendor ID.</div>   # noqa: E501

        :param app_vendor_id: The app_vendor_id of this DictionaryServiceAppLinkVendor.  # noqa: E501
        :type: str
        """

        self._app_vendor_id = app_vendor_id

    @property
    def app_vendor_name_ja(self):
        """Gets the app_vendor_name_ja of this DictionaryServiceAppLinkVendor.  # noqa: E501

        <div lang=\"ja\">アプリ計測ベンダー名（日本語）です。</div> <div lang=\"en\">App vendor name in Japanese.</div>   # noqa: E501

        :return: The app_vendor_name_ja of this DictionaryServiceAppLinkVendor.  # noqa: E501
        :rtype: str
        """
        return self._app_vendor_name_ja

    @app_vendor_name_ja.setter
    def app_vendor_name_ja(self, app_vendor_name_ja):
        """Sets the app_vendor_name_ja of this DictionaryServiceAppLinkVendor.

        <div lang=\"ja\">アプリ計測ベンダー名（日本語）です。</div> <div lang=\"en\">App vendor name in Japanese.</div>   # noqa: E501

        :param app_vendor_name_ja: The app_vendor_name_ja of this DictionaryServiceAppLinkVendor.  # noqa: E501
        :type: str
        """

        self._app_vendor_name_ja = app_vendor_name_ja

    @property
    def app_vendor_name_en(self):
        """Gets the app_vendor_name_en of this DictionaryServiceAppLinkVendor.  # noqa: E501

        <div lang=\"ja\">アプリ計測ベンダー名（英語）です。</div> <div lang=\"en\">App vendor name in English.</div>   # noqa: E501

        :return: The app_vendor_name_en of this DictionaryServiceAppLinkVendor.  # noqa: E501
        :rtype: str
        """
        return self._app_vendor_name_en

    @app_vendor_name_en.setter
    def app_vendor_name_en(self, app_vendor_name_en):
        """Sets the app_vendor_name_en of this DictionaryServiceAppLinkVendor.

        <div lang=\"ja\">アプリ計測ベンダー名（英語）です。</div> <div lang=\"en\">App vendor name in English.</div>   # noqa: E501

        :param app_vendor_name_en: The app_vendor_name_en of this DictionaryServiceAppLinkVendor.  # noqa: E501
        :type: str
        """

        self._app_vendor_name_en = app_vendor_name_en

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, DictionaryServiceAppLinkVendor):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, DictionaryServiceAppLinkVendor):
            return True

        return self.to_dict() != other.to_dict()
