# coding: utf-8

"""
    Yahoo!広告 検索広告 API リファレンス / Yahoo! JAPAN Ads Search Ads API Reference

    <div lang=\"ja\">Yahoo!広告 検索広告 APIのWebサービスについて説明します。</div> <div lang=\"en\">Search Ads API Web Services supported in Yahoo! JAPAN Ads API.</div> <div><a target=\"_blank\" href=\"https://github.com/yahoojp-marketing/ads-search-api-documents/blob/master/design/v12/Route.yaml\">OpenAPI Specification</a></div> <div lang=\"ja\"><a target=\"_blank\" href=\"https://github.com/yahoojp-marketing/ads-search-api-documents/blob/master/bestpractice/ja\">Best Practice</a></div> <div lang=\"en\"><a target=\"_blank\" href=\"https://github.com/yahoojp-marketing/ads-search-api-documents/blob/master/bestpractice/en\">Best Practice</a></div>   # noqa: E501

    The version of the OpenAPI document: v12
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from yahoo_search_api_v12.configuration import Configuration


class KeywordForecastMetricsServiceSelector(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'account_id': 'int',
        'date_interval': 'KeywordForecastMetricsServiceDateInterval',
        'start_date': 'str',
        'end_date': 'str',
        'keyword_plan_campaign': 'KeywordForecastMetricsServiceKeywordPlanCampaign'
    }

    attribute_map = {
        'account_id': 'accountId',
        'date_interval': 'dateInterval',
        'start_date': 'startDate',
        'end_date': 'endDate',
        'keyword_plan_campaign': 'keywordPlanCampaign'
    }

    def __init__(self, account_id=None, date_interval=None, start_date=None, end_date=None, keyword_plan_campaign=None, local_vars_configuration=None):  # noqa: E501
        """KeywordForecastMetricsServiceSelector - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._account_id = None
        self._date_interval = None
        self._start_date = None
        self._end_date = None
        self._keyword_plan_campaign = None
        self.discriminator = None

        self.account_id = account_id
        self.date_interval = date_interval
        self.start_date = start_date
        self.end_date = end_date
        self.keyword_plan_campaign = keyword_plan_campaign

    @property
    def account_id(self):
        """Gets the account_id of this KeywordForecastMetricsServiceSelector.  # noqa: E501

        <div lang=\"ja\">アカウントIDです。</div> <div lang=\"en\">Account ID.</div>   # noqa: E501

        :return: The account_id of this KeywordForecastMetricsServiceSelector.  # noqa: E501
        :rtype: int
        """
        return self._account_id

    @account_id.setter
    def account_id(self, account_id):
        """Sets the account_id of this KeywordForecastMetricsServiceSelector.

        <div lang=\"ja\">アカウントIDです。</div> <div lang=\"en\">Account ID.</div>   # noqa: E501

        :param account_id: The account_id of this KeywordForecastMetricsServiceSelector.  # noqa: E501
        :type: int
        """
        if self.local_vars_configuration.client_side_validation and account_id is None:  # noqa: E501
            raise ValueError("Invalid value for `account_id`, must not be `None`")  # noqa: E501

        self._account_id = account_id

    @property
    def date_interval(self):
        """Gets the date_interval of this KeywordForecastMetricsServiceSelector.  # noqa: E501


        :return: The date_interval of this KeywordForecastMetricsServiceSelector.  # noqa: E501
        :rtype: KeywordForecastMetricsServiceDateInterval
        """
        return self._date_interval

    @date_interval.setter
    def date_interval(self, date_interval):
        """Sets the date_interval of this KeywordForecastMetricsServiceSelector.


        :param date_interval: The date_interval of this KeywordForecastMetricsServiceSelector.  # noqa: E501
        :type: KeywordForecastMetricsServiceDateInterval
        """

        self._date_interval = date_interval

    @property
    def start_date(self):
        """Gets the start_date of this KeywordForecastMetricsServiceSelector.  # noqa: E501

        <div lang=\"ja\">dateIntervalがCUSTOM_DATEのときに指定する開始日です。<br> 現在より先の日付、かつ一年未満である必要があります。<br> ※フォーマット：yyyyMMdd</div> <div lang=\"en\">Start date specified when dateInterval is CUSTOM_DATE.<br> Must be earlier than the current date and less than a year old.<br> * Format: yyyyMMdd</div>   # noqa: E501

        :return: The start_date of this KeywordForecastMetricsServiceSelector.  # noqa: E501
        :rtype: str
        """
        return self._start_date

    @start_date.setter
    def start_date(self, start_date):
        """Sets the start_date of this KeywordForecastMetricsServiceSelector.

        <div lang=\"ja\">dateIntervalがCUSTOM_DATEのときに指定する開始日です。<br> 現在より先の日付、かつ一年未満である必要があります。<br> ※フォーマット：yyyyMMdd</div> <div lang=\"en\">Start date specified when dateInterval is CUSTOM_DATE.<br> Must be earlier than the current date and less than a year old.<br> * Format: yyyyMMdd</div>   # noqa: E501

        :param start_date: The start_date of this KeywordForecastMetricsServiceSelector.  # noqa: E501
        :type: str
        """

        self._start_date = start_date

    @property
    def end_date(self):
        """Gets the end_date of this KeywordForecastMetricsServiceSelector.  # noqa: E501

        <div lang=\"ja\">dateIntervalがCUSTOM_DATEのときに指定する終了日です。<br> 現在より先の日付、かつ一年未満である必要があります。<br> ※フォーマット：yyyyMMdd</div> <div lang=\"en\">End date specified when dateInterval is CUSTOM_DATE.<br> Must be earlier than the current date and less than a year old.<br> * Format: yyyyMMdd</div>   # noqa: E501

        :return: The end_date of this KeywordForecastMetricsServiceSelector.  # noqa: E501
        :rtype: str
        """
        return self._end_date

    @end_date.setter
    def end_date(self, end_date):
        """Sets the end_date of this KeywordForecastMetricsServiceSelector.

        <div lang=\"ja\">dateIntervalがCUSTOM_DATEのときに指定する終了日です。<br> 現在より先の日付、かつ一年未満である必要があります。<br> ※フォーマット：yyyyMMdd</div> <div lang=\"en\">End date specified when dateInterval is CUSTOM_DATE.<br> Must be earlier than the current date and less than a year old.<br> * Format: yyyyMMdd</div>   # noqa: E501

        :param end_date: The end_date of this KeywordForecastMetricsServiceSelector.  # noqa: E501
        :type: str
        """

        self._end_date = end_date

    @property
    def keyword_plan_campaign(self):
        """Gets the keyword_plan_campaign of this KeywordForecastMetricsServiceSelector.  # noqa: E501


        :return: The keyword_plan_campaign of this KeywordForecastMetricsServiceSelector.  # noqa: E501
        :rtype: KeywordForecastMetricsServiceKeywordPlanCampaign
        """
        return self._keyword_plan_campaign

    @keyword_plan_campaign.setter
    def keyword_plan_campaign(self, keyword_plan_campaign):
        """Sets the keyword_plan_campaign of this KeywordForecastMetricsServiceSelector.


        :param keyword_plan_campaign: The keyword_plan_campaign of this KeywordForecastMetricsServiceSelector.  # noqa: E501
        :type: KeywordForecastMetricsServiceKeywordPlanCampaign
        """

        self._keyword_plan_campaign = keyword_plan_campaign

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, KeywordForecastMetricsServiceSelector):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, KeywordForecastMetricsServiceSelector):
            return True

        return self.to_dict() != other.to_dict()
