# coding: utf-8

"""
    Yahoo!広告 検索広告 API リファレンス / Yahoo! JAPAN Ads Search Ads API Reference

    <div lang=\"ja\">Yahoo!広告 検索広告 APIのWebサービスについて説明します。</div> <div lang=\"en\">Search Ads API Web Services supported in Yahoo! JAPAN Ads API.</div> <div><a target=\"_blank\" href=\"https://github.com/yahoojp-marketing/ads-search-api-documents/blob/master/design/v12/Route.yaml\">OpenAPI Specification</a></div> <div lang=\"ja\"><a target=\"_blank\" href=\"https://github.com/yahoojp-marketing/ads-search-api-documents/blob/master/bestpractice/ja\">Best Practice</a></div> <div lang=\"en\"><a target=\"_blank\" href=\"https://github.com/yahoojp-marketing/ads-search-api-documents/blob/master/bestpractice/en\">Best Practice</a></div>   # noqa: E501

    The version of the OpenAPI document: v12
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from yahoo_search_api_v12.configuration import Configuration


class ReportDefinitionServiceReportFilter(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'field': 'str',
        'filter_operator': 'ReportDefinitionServiceFilterOperator',
        'values': 'list[str]'
    }

    attribute_map = {
        'field': 'field',
        'filter_operator': 'filterOperator',
        'values': 'values'
    }

    def __init__(self, field=None, filter_operator=None, values=None, local_vars_configuration=None):  # noqa: E501
        """ReportDefinitionServiceReportFilter - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._field = None
        self._filter_operator = None
        self._values = None
        self.discriminator = None

        self.field = field
        self.filter_operator = filter_operator
        self.values = values

    @property
    def field(self):
        """Gets the field of this ReportDefinitionServiceReportFilter.  # noqa: E501

        <div lang=\"ja\">フィルタ条件を設定する表示項目です。<br> ADD時、このフィールドは必須となります。 </div> <div lang=\"en\">Field which you set filtering.<br> This field is required in ADD operation.</div>   # noqa: E501

        :return: The field of this ReportDefinitionServiceReportFilter.  # noqa: E501
        :rtype: str
        """
        return self._field

    @field.setter
    def field(self, field):
        """Sets the field of this ReportDefinitionServiceReportFilter.

        <div lang=\"ja\">フィルタ条件を設定する表示項目です。<br> ADD時、このフィールドは必須となります。 </div> <div lang=\"en\">Field which you set filtering.<br> This field is required in ADD operation.</div>   # noqa: E501

        :param field: The field of this ReportDefinitionServiceReportFilter.  # noqa: E501
        :type: str
        """

        self._field = field

    @property
    def filter_operator(self):
        """Gets the filter_operator of this ReportDefinitionServiceReportFilter.  # noqa: E501


        :return: The filter_operator of this ReportDefinitionServiceReportFilter.  # noqa: E501
        :rtype: ReportDefinitionServiceFilterOperator
        """
        return self._filter_operator

    @filter_operator.setter
    def filter_operator(self, filter_operator):
        """Sets the filter_operator of this ReportDefinitionServiceReportFilter.


        :param filter_operator: The filter_operator of this ReportDefinitionServiceReportFilter.  # noqa: E501
        :type: ReportDefinitionServiceFilterOperator
        """

        self._filter_operator = filter_operator

    @property
    def values(self):
        """Gets the values of this ReportDefinitionServiceReportFilter.  # noqa: E501

        <div lang=\"ja\">表示項目の条件値です。<br> ADD時、このフィールドは必須となります。</div> <div lang=\"en\">Condition values to filter the field.<br> This field is required in ADD operation.</div>   # noqa: E501

        :return: The values of this ReportDefinitionServiceReportFilter.  # noqa: E501
        :rtype: list[str]
        """
        return self._values

    @values.setter
    def values(self, values):
        """Sets the values of this ReportDefinitionServiceReportFilter.

        <div lang=\"ja\">表示項目の条件値です。<br> ADD時、このフィールドは必須となります。</div> <div lang=\"en\">Condition values to filter the field.<br> This field is required in ADD operation.</div>   # noqa: E501

        :param values: The values of this ReportDefinitionServiceReportFilter.  # noqa: E501
        :type: list[str]
        """

        self._values = values

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ReportDefinitionServiceReportFilter):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, ReportDefinitionServiceReportFilter):
            return True

        return self.to_dict() != other.to_dict()
